#!/bin/sh
#set -x
export USBPATH=/mnt/usb
export BACKUPDIR_FIRM=$USBPATH/spsbackup
export BACKUPDIR_PROG=$BACKUPDIR_FIRM/data/programs
export BACKUPDIR_RESULT=$BACKUPDIR_FIRM/data/results
export BACKUPDIR_RESULT=$BACKUPDIR_CONFIG/data/config
export BOOTSH_LOG=$USBPATH/bootlog
export FIRMWAREDIR=/firmware
export PROGDIR=$FIRMWAREDIR/data/programs
export RESULTDIR=$FIRMWAREDIR/data/results
export TMP_READY=/tmp/ready


DoCommandWithProgress()
{
   TMP_READY=/tmp/ready
   #echo $1
   sh -c "$1 ; touch $TMP_READY" &
   until [ -f $TMP_READY ]
   do
      echo -n "*"
      sleep 1
   done
   echo ""
   rm $TMP_READY
}

#echo "********* Bootscript *********"

# IP-Settings auf Console anzeigen
	ifconfig eth0 | grep inet >/dev/null 2>&1

sleep 1

export MountText=`mount | grep "$USBPATH" | wc -l`
#echo "****** $MountText ****"
if [ $MountText -eq 0 ]; then
   #echo "USB not mounted"
   #echo "Do mount"
   mount -t vfat /dev/sda $USBPATH >/dev/null 2>&1 || mount -t vfat /dev/sda1 $USBPATH >/dev/null 2>&1
   RC=$?

   if [ $RC != "0" ]; then
      echo "No USB device found"
   fi
fi

export MountText=`mount | grep "$USBPATH" | wc -l`
#echo "***$MountText***"
if [ $MountText -gt 0 ]; then
   echo "USB device found"
   echo "Log Start:" >$USBPATH/bootlog 2>&1
#   date +%d-%m-%y-%T 
   date >>$USBPATH/bootlog 2>&1

   # IP-Settings auf USB-Stick speichern
   ifconfig eth0 >$USBPATH/ipsettings 

   #echo "Check autoupdate file"
   if [ -f $USBPATH/autoupdate -o -f $USBPATH/multiupdate ]; then
      echo "Autoupdate found"  #--> check firmware file"
      # Do Backup
      echo "Creating USB Backup"
      mkdir -p $BACKUPDIR_FIRM >>$USBPATH/bootlog 2>&1
      mkdir -p $BACKUPDIR_PROG >>$USBPATH/bootlog 2>&1
      mkdir -p $BACKUPDIR_RESULT >>$USBPATH/bootlog 2>&1

      #echo "Backup firmware"
      #DoCommandWithProgress "cp $FIRMWAREDIR/Firmware $BACKUPDIR_FIRM"
	  cp $FIRMWAREDIR/Firmware $BACKUPDIR_FIRM >>$USBPATH/bootlog 2>&1
      #echo -e "\nBackup programs"
      #DoCommandWithProgress "cp -r $PROGDIR/* $BACKUPDIR_PROG"
	  cp -r $PROGDIR/* $BACKUPDIR_PROG >>$USBPATH/bootlog 2>&1
      #echo -e "\nBackup results"
      #DoCommandWithProgress "cp -r $RESULTDIR/* $BACKUPDIR_RESULT"
	  cp -r $RESULTDIR/* $BACKUPDIR_RESULT >>$USBPATH/bootlog 2>&1
      
	  if [ -f $USBPATH/1800.tar ]; then
         echo "Updating Firmware"

         #echo -e "\nFree space before remove files"
         #df -h /dev/mtdblock3 /dev/mtdblock4

         #Remove Files for free space
         #echo "Remove files for free space"
         #rm -r $PROGDIR/*
         #rm -r $RESULTDIR/*

         #echo -e "\nFree space after remove files"
         #df -h /dev/mtdblock3 /dev/mtdblock4

         tar -xf $USBPATH/1800.tar --directory=/tmp setup.sh >>$USBPATH/bootlog 2>&1
         chmod 777 /tmp/setup.sh
         DoCommandWithProgress "/tmp/setup.sh $USBPATH/1800.tar"

         echo "Firmwareupdate done"
         rm -f $USBPATH/autoupdate >>$USBPATH/bootlog 2>&1
         #echo "Autoupdate file deleted" >>$USBPATH/bootlog 2>&1

         #Restore files
         #echo "Restore files"
         #cp -r $BACKUPDIR_PROG/* $PROGDIR
         #cp -r $BACKUPDIR_RESULT/* $RESULTDIR

         #echo -e "\nFree space after restore"
         #df -h /dev/mtdblock3 /dev/mtdblock4
      fi
   fi

   umount $USBPATH
   #echo "USB unmounted" >>$USBPATH/bootlog 2>&1
fi
