<?xml version="1.0" encoding="windows-1250"?>
<!-- XSLT style sheet for transformation of XML documents of the result tests
!!! encoding="windows-1250" in xsl:output and ?xml
!!! <title>
-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"xhtml1-transitional.dtd">
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="html" encoding="windows-1250"/>
	<xsl:template match="/">
		<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="cs">
			<head>
				<meta http-equiv="content-type" content="text/html; charset=windows-1250"/>
				<title>Test protocoll&nbsp;-&nbsp;<xsl:value-of select="SPS-RESULTS/TEST-RESULTS/ProgramFile"/></title>
				<link href="res_style.css" rel="stylesheet" type="text/css"/>
			</head>
			
			<body>
				<table border="0" cellspacing="3" cellpadding="0" width="100%">
					<xsl:apply-templates select="SPS-RESULTS/TEST-RESULTS"/>
				</table>
			</body>
		</html>
	</xsl:template>
	
	<xsl:template match="TEST-RESULTS">
   <table border="0">
		<tr valign="top">
			<td colspan="4">
				<b>----------------------------------------------------------------------------------------------------------------------</b>
			</td>
		</tr>
		<tr valign="top">
			<td colspan="4">
				<b>----------------------------------------------------------------------------------------------------------------------</b>
			</td>
		</tr>
		</table>
		
		<table border="0">
		  <tr valign="top">
			  <td colspan="2" rowspan="{count(*[not(starts-with(local-name(),'STEP')) and string-length(.) > 0]) + 1}"></td>
		  </tr>
		  <xsl:apply-templates select="StationID[string-length(.) > 0]"/>
		  <xsl:apply-templates select="ProgramFile"/>
		  <xsl:apply-templates select="StartDate"/>
		  <xsl:apply-templates select="EndDate"/>
		  <xsl:apply-templates select="Device[string-length(.) > 0]"/>
		  <xsl:apply-templates select="UserTester"/>
		  <xsl:apply-templates select="TotalResult"/>
		  <xsl:apply-templates select="SerialNr[string-length(.) > 0]"/>
		  <xsl:apply-templates select="ProductID[string-length(.) > 0]"/>
		  <xsl:apply-templates select="Remark[string-length(.) > 0]"/>
		  <xsl:apply-templates select="Comment1[string-length(.) > 0]"/>
		  <xsl:apply-templates select="Comment2[string-length(.) > 0]"/>
		</table>
		
		<table border="0">
  		<xsl:for-each select="*[starts-with(name(),'STEP')]">
        <BR/>
	  		<xsl:apply-templates select="."/>
  		</xsl:for-each>
		</table>
    <BR/>
    <BR/>
    <BR/>
    <BR/>
	</xsl:template>
	

	<!-- *************** Step TV (text visual test) ************************** -->
	<xsl:template match="STEP_TV">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
  		
   		<xsl:choose>
   			<xsl:when test="TestType = 1">
 					<xsl:apply-templates select="MyResult"/>
 			    <xsl:call-template name="VT_method"/>
 					<xsl:call-template name="Info"/>
   			</xsl:when>
    			
   			<xsl:when test="TestType = 2">
 					<xsl:apply-templates select="MyResult"/>
 			    <xsl:call-template name="VT_method"/>
 					<xsl:call-template name="Question"/>
 					<xsl:apply-templates select="Answer"/>
   			</xsl:when>
    			
   			<xsl:when test="TestType = 3">
     			<xsl:choose>
     				<xsl:when test="Umode = 1">
     					<xsl:apply-templates select="MyResult"/>
     			    <xsl:call-template name="VT_method"/>
     					<xsl:call-template name="Question"/>
 			        <xsl:call-template name="ShowRealValue">  <!-- U nom int -->
                <xsl:with-param name="ParamName">U</xsl:with-param>
                <xsl:with-param name="ParamIndex">nom</xsl:with-param>
                <xsl:with-param name="ParamAdd">int</xsl:with-param>
                <xsl:with-param name="ParamValue" select="Unom"/>
                <xsl:with-param name="ParamUnit">V</xsl:with-param>
              </xsl:call-template>
     					<xsl:apply-templates select="Answer"/>
     				</xsl:when>
   				
     				<xsl:when test="Umode = 2">
     					<xsl:apply-templates select="MyResult"/>
     			    <xsl:call-template name="VT_method"/>
     					<xsl:call-template name="Question"/>
 			        <xsl:call-template name="ShowRealValue">  <!-- U nom ext -->
                <xsl:with-param name="ParamName">U</xsl:with-param>
                <xsl:with-param name="ParamIndex">nom</xsl:with-param>
                <xsl:with-param name="ParamAdd">ext</xsl:with-param>
                <xsl:with-param name="ParamValue" select="Unom"/>
                <xsl:with-param name="ParamUnit">V</xsl:with-param>
              </xsl:call-template>
     					<xsl:apply-templates select="Ureal"/>
     					<xsl:apply-templates select="Answer"/>
 	    			</xsl:when>
   	    			
            <xsl:otherwise></xsl:otherwise>
     			</xsl:choose>
   			</xsl:when>

   			<xsl:when test="TestType = 4">
 					<xsl:apply-templates select="MyResult"/>
 			    <xsl:call-template name="VT_method"/>
 					<xsl:call-template name="Question"/>
 					<xsl:apply-templates select="Answer"/>
   			</xsl:when>
   		</xsl:choose>
  	</table>
	</xsl:template>


	<!-- *************** Step PV (picture visual test) *********************** -->
	<xsl:template match="STEP_PV">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">

   		<xsl:choose>
   			<xsl:when test="TestType = 1">
 					<xsl:apply-templates select="MyResult"/>
 			    <xsl:call-template name="VT_method"/>
 					<xsl:apply-templates select="FileName[string-length(.) > 0]"/>
   			</xsl:when>
    			
   			<xsl:when test="TestType = 2">
 					<xsl:apply-templates select="MyResult"/>
 			    <xsl:call-template name="VT_method"/>
 					<xsl:apply-templates select="FileName[string-length(.) > 0]"/>
 					<xsl:apply-templates select="Answer"/>
   			</xsl:when>
    			
   			<xsl:when test="TestType = 3">
     			<xsl:choose>
     				<xsl:when test="Umode = 1">
     					<xsl:apply-templates select="MyResult"/>
     			    <xsl:call-template name="VT_method"/>
     					<xsl:apply-templates select="FileName[string-length(.) > 0]"/>
 			        <xsl:call-template name="ShowRealValue">  <!-- U nom int -->
                <xsl:with-param name="ParamName">U</xsl:with-param>
                <xsl:with-param name="ParamIndex">nom</xsl:with-param>
                <xsl:with-param name="ParamAdd">int</xsl:with-param>
                <xsl:with-param name="ParamValue" select="Unom"/>
                <xsl:with-param name="ParamUnit">V</xsl:with-param>
              </xsl:call-template>
     					<xsl:apply-templates select="Answer"/>
     				</xsl:when>

     				<xsl:when test="Umode = 2">
     					<xsl:apply-templates select="MyResult"/>
     			    <xsl:call-template name="VT_method"/>
     					<xsl:apply-templates select="FileName[string-length(.) > 0]"/>
 			        <xsl:call-template name="ShowRealValue">  <!-- U nom ext -->
                <xsl:with-param name="ParamName">U</xsl:with-param>
                <xsl:with-param name="ParamIndex">nom</xsl:with-param>
                <xsl:with-param name="ParamAdd">ext</xsl:with-param>
                <xsl:with-param name="ParamValue" select="Unom"/>
                <xsl:with-param name="ParamUnit">V</xsl:with-param>
              </xsl:call-template>
     					<xsl:apply-templates select="Ureal"/>
     					<xsl:apply-templates select="Answer"/>
 	    			</xsl:when>
 	    			
            <xsl:otherwise></xsl:otherwise>
     			</xsl:choose>
   			</xsl:when>

   			<xsl:when test="TestType = 4">
 					<xsl:apply-templates select="MyResult"/>
 			    <xsl:call-template name="VT_method"/>
 					<xsl:apply-templates select="FileName[string-length(.) > 0]"/>
 					<xsl:apply-templates select="Answer"/>
   			</xsl:when>
   		</xsl:choose>
   	</table>
	</xsl:template>


  <!-- *************** Step AI (leakage current test) ********************** -->
  <xsl:template match="STEP_AI" name="STEP_AI">
    <xsl:call-template name="STPHDR"/>
    <table border="0">
      <xsl:apply-templates select="MyResult"/>
      
 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>
      
 			<xsl:call-template name="ShowRealValue">  <!-- U nom -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

<!--  			<xsl:call-template name="ShowRealValue">  F nom
        <xsl:with-param name="ParamName">F</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Fnom"/>
        <xsl:with-param name="ParamUnit">Hz</xsl:with-param>
      </xsl:call-template>
 -->
 			<xsl:call-template name="ShowRealValue">  <!-- I max -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imax"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

<!--  			<xsl:call-template name="AI_method"/>
 --> 			
 			<xsl:call-template name="ShowRealValue">  <!-- I real -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ireal"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

<!--  			<xsl:call-template name="ShowRealValue">   I leak 
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">leak</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ileak"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>
 -->
  		<xsl:apply-templates select="ErrCode [. > 0]"/>
 		</table>
	</xsl:template>
	
	
	<!-- *************** Step BC (barcode reading test) *************************** -->
	<xsl:template match="STEP_BC">
		<xsl:call-template name="STPHDR"/>
   	<table border="0">

      <tr valign="top">
    		<td class="resname"><xsl:value-of select="ValueName"/>:</td>
	    	<td><xsl:value-of select="Barcode"/></td>
    	</tr>

		</table>
	</xsl:template>


	<!-- *************** Step CT (continuity test) *************************** -->
	<xsl:template match="STEP_CT">
		<xsl:call-template name="STPHDR"/>
   	<table border="0">
 			<xsl:apply-templates select="MyResult"/>
 			<xsl:call-template name="Imin_in_mA"/>

 			<xsl:call-template name="ShowRealValue">  <!-- I max -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imax"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I real -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ireal"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

		</table>
	</xsl:template>
	
	
	<!-- *************** Step DG (continuity test) *************************** -->
	<xsl:template match="STEP_DG">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
		  <xsl:apply-templates select="MyResult"/>
  		<xsl:call-template name="Imin_in_mA"/>

 			<xsl:call-template name="ShowRealValue">  <!-- I max -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imax"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I real -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ireal"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

		</table>
	</xsl:template>

	
	<!-- *************** Step F1 (function test) ***************************** -->
	<xsl:template match="STEP_F1">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- Good time -->
        <xsl:with-param name="ParamName">Good time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="GoodTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

  		<xsl:apply-templates select="GoodTimeOk"/>
  		
<!--  			<xsl:call-template name="ShowRealValue">  U nom
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>
 -->
<!--  			<xsl:call-template name="ShowRealValue">  F nom
        <xsl:with-param name="ParamName">F</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Fnom"/>
        <xsl:with-param name="ParamUnit">Hz</xsl:with-param>
      </xsl:call-template>
 -->
 			<xsl:call-template name="ShowRealValue">  <!-- I min -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imin"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I max -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imax"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I real -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ireal"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

<!--  			<xsl:call-template name="ShowRealValue">  U real
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ureal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>
 -->
      <xsl:choose>
        <xsl:when test="AlogUse1 = 'True'">
    			<xsl:apply-templates select="AlogRange1"/>
    			<xsl:apply-templates select="AlogUnit1"/>

 			    <xsl:call-template name="ShowRealValue">  <!-- Analog 1 min -->
            <xsl:with-param name="ParamName">Analog 1</xsl:with-param>
            <xsl:with-param name="ParamIndex">min</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="AlogMin1"/>
            <xsl:with-param name="ParamUnit"><xsl:value-of select="AlogUnit1"/></xsl:with-param>
          </xsl:call-template>

 			    <xsl:call-template name="ShowRealValue">  <!-- Analog 1 max -->
            <xsl:with-param name="ParamName">Analog 1</xsl:with-param>
            <xsl:with-param name="ParamIndex">max</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="AlogMax1"/>
            <xsl:with-param name="ParamUnit"><xsl:value-of select="AlogUnit1"/></xsl:with-param>
          </xsl:call-template>

 			    <xsl:call-template name="ShowRealValue">  <!-- Analog 1 real -->
            <xsl:with-param name="ParamName">Analog 1</xsl:with-param>
            <xsl:with-param name="ParamIndex">real</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="AlogReal1"/>
            <xsl:with-param name="ParamUnit"><xsl:value-of select="AlogUnit1"/></xsl:with-param>
          </xsl:call-template>
    		</xsl:when>
        <xsl:otherwise/>
      </xsl:choose>

      <xsl:choose>
        <xsl:when test="AlogUse2 = 'True'">
    			<xsl:apply-templates select="AlogRange2"/>
    			<xsl:apply-templates select="AlogUnit2"/>
    			
 			    <xsl:call-template name="ShowRealValue">  <!-- Analog 2 min -->
            <xsl:with-param name="ParamName">Analog 2</xsl:with-param>
            <xsl:with-param name="ParamIndex">min</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="AlogMin2"/>
            <xsl:with-param name="ParamUnit"><xsl:value-of select="AlogUnit2"/></xsl:with-param>
          </xsl:call-template>

 			    <xsl:call-template name="ShowRealValue">  <!-- Analog 2 max -->
            <xsl:with-param name="ParamName">Analog 2</xsl:with-param>
            <xsl:with-param name="ParamIndex">max</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="AlogMax2"/>
            <xsl:with-param name="ParamUnit"><xsl:value-of select="AlogUnit2"/></xsl:with-param>
          </xsl:call-template>

 			    <xsl:call-template name="ShowRealValue">  <!-- Analog 2 real -->
            <xsl:with-param name="ParamName">Analog 2</xsl:with-param>
            <xsl:with-param name="ParamIndex">real</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="AlogReal2"/>
            <xsl:with-param name="ParamUnit"><xsl:value-of select="AlogUnit2"/></xsl:with-param>
          </xsl:call-template>
    		</xsl:when>
        <xsl:otherwise/>
      </xsl:choose>

  	</table>
	</xsl:template>


	<!-- *************** Step FD (field direction test) ********************** -->
	<xsl:template match="STEP_FD">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="Direction"/>
			
 			<xsl:call-template name="ShowRealValue">  <!-- Frequency min -->
        <xsl:with-param name="ParamName">Freq</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="FreqMin"/>
        <xsl:with-param name="ParamUnit">Hz</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- Frequency max -->
        <xsl:with-param name="ParamName">Freq</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="FreqMax"/>
        <xsl:with-param name="ParamUnit">Hz</xsl:with-param>
      </xsl:call-template>

      <xsl:choose>
        <xsl:when test="Direction = DirReal">
          <xsl:call-template name="Good_DirReal"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:call-template name="Fail_DirReal"/>
        </xsl:otherwise>
      </xsl:choose>

 			<xsl:call-template name="ShowRealValue">  <!-- Frequency real -->
        <xsl:with-param name="ParamName">Freq</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="FreqReal"/>
        <xsl:with-param name="ParamUnit">Hz</xsl:with-param>
      </xsl:call-template>

  	</table>
	</xsl:template>


	<!-- *************** Step FK (function test) ***************************** -->
	<xsl:template match="STEP_FK">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- Good time -->
        <xsl:with-param name="ParamName">Good time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="GoodTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

  		<xsl:apply-templates select="GoodTimeOk"/>

			<xsl:apply-templates select="CosPhiMin"/>
  		<xsl:apply-templates select="CosPhiMax"/>
      <xsl:choose>
        <xsl:when test="CosPhiReal >= CosPhiMin and CosPhiReal &lt;= CosPhiMax">
          <xsl:call-template name="Good_CosPhiReal"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:call-template name="Fail_CosPhiReal"/>
        </xsl:otherwise>
      </xsl:choose>

 			<xsl:call-template name="ShowRealValue">  <!-- P min -->
        <xsl:with-param name="ParamName">P</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Pmin"/>
        <xsl:with-param name="ParamUnit">W</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- P max -->
        <xsl:with-param name="ParamName">P</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Pmax"/>
        <xsl:with-param name="ParamUnit">W</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- P real -->
        <xsl:with-param name="ParamName">P</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="PowerReal"/>
        <xsl:with-param name="ParamUnit">W</xsl:with-param>
      </xsl:call-template>

      <xsl:choose>
        <xsl:when test="UsePhase1 = 'True'">
    			<xsl:call-template name="ShowRealValue">  <!-- I min (phase 1) -->
            <xsl:with-param name="ParamName">I</xsl:with-param>
            <xsl:with-param name="ParamIndex">min</xsl:with-param>
            <xsl:with-param name="ParamAdd">(phase 1)</xsl:with-param>
            <xsl:with-param name="ParamValue" select="IminL1"/>
            <xsl:with-param name="ParamUnit">A</xsl:with-param>
          </xsl:call-template>

   			  <xsl:call-template name="ShowRealValue">  <!-- I max (phase 1) -->
            <xsl:with-param name="ParamName">I</xsl:with-param>
            <xsl:with-param name="ParamIndex">max</xsl:with-param>
            <xsl:with-param name="ParamAdd">(phase 1)</xsl:with-param>
            <xsl:with-param name="ParamValue" select="ImaxL1"/>
            <xsl:with-param name="ParamUnit">A</xsl:with-param>
          </xsl:call-template>

 			    <xsl:call-template name="ShowRealValue">  <!-- I real (phase 1) -->
            <xsl:with-param name="ParamName">I</xsl:with-param>
            <xsl:with-param name="ParamIndex">real</xsl:with-param>
            <xsl:with-param name="ParamAdd">(phase 1)</xsl:with-param>
            <xsl:with-param name="ParamValue" select="IrealL1"/>
            <xsl:with-param name="ParamUnit">A</xsl:with-param>
          </xsl:call-template>

          <xsl:choose>
            <xsl:when test="CheckU_L1 = 'True'">
    			    <xsl:call-template name="ShowRealValue">  <!-- U min (phase 1) -->
                <xsl:with-param name="ParamName">U</xsl:with-param>
                <xsl:with-param name="ParamIndex">min</xsl:with-param>
                <xsl:with-param name="ParamAdd">(phase 1)</xsl:with-param>
                <xsl:with-param name="ParamValue" select="UminL1"/>
                <xsl:with-param name="ParamUnit">V</xsl:with-param>
              </xsl:call-template>

   			      <xsl:call-template name="ShowRealValue">  <!-- U max (phase 1) -->
                <xsl:with-param name="ParamName">U</xsl:with-param>
                <xsl:with-param name="ParamIndex">max</xsl:with-param>
                <xsl:with-param name="ParamAdd">(phase 1)</xsl:with-param>
                <xsl:with-param name="ParamValue" select="UmaxL1"/>
                <xsl:with-param name="ParamUnit">V</xsl:with-param>
              </xsl:call-template>

 			        <xsl:call-template name="ShowRealValue">  <!-- U real (phase 1) -->
                <xsl:with-param name="ParamName">U</xsl:with-param>
                <xsl:with-param name="ParamIndex">real</xsl:with-param>
                <xsl:with-param name="ParamAdd">(phase 1)</xsl:with-param>
                <xsl:with-param name="ParamValue" select="UrealL1"/>
                <xsl:with-param name="ParamUnit">V</xsl:with-param>
              </xsl:call-template>
            </xsl:when>
            <xsl:otherwise/>
          </xsl:choose>
          
    		</xsl:when>
        <xsl:otherwise/>
      </xsl:choose>


      <xsl:choose>
        <xsl:when test="UsePhase2 = 'True'">
 			    <xsl:call-template name="ShowRealValue">  <!-- I min (phase 2) -->
            <xsl:with-param name="ParamName">I</xsl:with-param>
            <xsl:with-param name="ParamIndex">min</xsl:with-param>
            <xsl:with-param name="ParamAdd">(phase 2)</xsl:with-param>
            <xsl:with-param name="ParamValue" select="IminL2"/>
            <xsl:with-param name="ParamUnit">A</xsl:with-param>
          </xsl:call-template>

 		    	<xsl:call-template name="ShowRealValue">  <!-- I max (phase 2) -->
            <xsl:with-param name="ParamName">I</xsl:with-param>
            <xsl:with-param name="ParamIndex">max</xsl:with-param>
            <xsl:with-param name="ParamAdd">(phase 2)</xsl:with-param>
            <xsl:with-param name="ParamValue" select="ImaxL2"/>
            <xsl:with-param name="ParamUnit">A</xsl:with-param>
          </xsl:call-template>

    			<xsl:call-template name="ShowRealValue">  <!-- I real (phase 2) -->
            <xsl:with-param name="ParamName">I</xsl:with-param>
            <xsl:with-param name="ParamIndex">real</xsl:with-param>
            <xsl:with-param name="ParamAdd">(phase 2)</xsl:with-param>
            <xsl:with-param name="ParamValue" select="IrealL2"/>
            <xsl:with-param name="ParamUnit">A</xsl:with-param>
          </xsl:call-template>

          <xsl:choose>
            <xsl:when test="CheckU_L2 = 'True'">
    			    <xsl:call-template name="ShowRealValue">  <!-- U min (phase 2) -->
                <xsl:with-param name="ParamName">U</xsl:with-param>
                <xsl:with-param name="ParamIndex">min</xsl:with-param>
                <xsl:with-param name="ParamAdd">(phase 2)</xsl:with-param>
                <xsl:with-param name="ParamValue" select="UminL2"/>
                <xsl:with-param name="ParamUnit">V</xsl:with-param>
              </xsl:call-template>

   			      <xsl:call-template name="ShowRealValue">  <!-- U max (phase 2) -->
                <xsl:with-param name="ParamName">U</xsl:with-param>
                <xsl:with-param name="ParamIndex">max</xsl:with-param>
                <xsl:with-param name="ParamAdd">(phase 2)</xsl:with-param>
                <xsl:with-param name="ParamValue" select="UmaxL2"/>
                <xsl:with-param name="ParamUnit">V</xsl:with-param>
              </xsl:call-template>

 			        <xsl:call-template name="ShowRealValue">  <!-- U real (phase 2) -->
                <xsl:with-param name="ParamName">U</xsl:with-param>
                <xsl:with-param name="ParamIndex">real</xsl:with-param>
                <xsl:with-param name="ParamAdd">(phase 2)</xsl:with-param>
                <xsl:with-param name="ParamValue" select="UrealL2"/>
                <xsl:with-param name="ParamUnit">V</xsl:with-param>
              </xsl:call-template>
            </xsl:when>
            <xsl:otherwise/>
          </xsl:choose>

    		</xsl:when>
        <xsl:otherwise/>
      </xsl:choose>


      <xsl:choose>
        <xsl:when test="UsePhase3 = 'True'">
    			<xsl:call-template name="ShowRealValue">  <!-- I min (phase 3) -->
            <xsl:with-param name="ParamName">I</xsl:with-param>
            <xsl:with-param name="ParamIndex">min</xsl:with-param>
            <xsl:with-param name="ParamAdd">(phase 3)</xsl:with-param>
            <xsl:with-param name="ParamValue" select="IminL3"/>
            <xsl:with-param name="ParamUnit">A</xsl:with-param>
          </xsl:call-template>

 			    <xsl:call-template name="ShowRealValue">  <!-- I max (phase 3) -->
            <xsl:with-param name="ParamName">I</xsl:with-param>
            <xsl:with-param name="ParamIndex">max</xsl:with-param>
            <xsl:with-param name="ParamAdd">(phase 3)</xsl:with-param>
            <xsl:with-param name="ParamValue" select="ImaxL3"/>
            <xsl:with-param name="ParamUnit">A</xsl:with-param>
          </xsl:call-template>

 			    <xsl:call-template name="ShowRealValue">  <!-- I real (phase 3) -->
            <xsl:with-param name="ParamName">I</xsl:with-param>
            <xsl:with-param name="ParamIndex">real</xsl:with-param>
            <xsl:with-param name="ParamAdd">(phase 3)</xsl:with-param>
            <xsl:with-param name="ParamValue" select="IrealL3"/>
            <xsl:with-param name="ParamUnit">A</xsl:with-param>
          </xsl:call-template>
          
          <xsl:choose>
            <xsl:when test="CheckU_L3 = 'True'">
    			    <xsl:call-template name="ShowRealValue">  <!-- U min (phase 3) -->
                <xsl:with-param name="ParamName">U</xsl:with-param>
                <xsl:with-param name="ParamIndex">min</xsl:with-param>
                <xsl:with-param name="ParamAdd">(phase 3)</xsl:with-param>
                <xsl:with-param name="ParamValue" select="UminL3"/>
                <xsl:with-param name="ParamUnit">V</xsl:with-param>
              </xsl:call-template>

   			      <xsl:call-template name="ShowRealValue">  <!-- U max (phase 3) -->
                <xsl:with-param name="ParamName">U</xsl:with-param>
                <xsl:with-param name="ParamIndex">max</xsl:with-param>
                <xsl:with-param name="ParamAdd">(phase 3)</xsl:with-param>
                <xsl:with-param name="ParamValue" select="UmaxL3"/>
                <xsl:with-param name="ParamUnit">V</xsl:with-param>
              </xsl:call-template>

 			        <xsl:call-template name="ShowRealValue">  <!-- U real (phase 3) -->
                <xsl:with-param name="ParamName">U</xsl:with-param>
                <xsl:with-param name="ParamIndex">real</xsl:with-param>
                <xsl:with-param name="ParamAdd">(phase 3)</xsl:with-param>
                <xsl:with-param name="ParamValue" select="UrealL3"/>
                <xsl:with-param name="ParamUnit">V</xsl:with-param>
              </xsl:call-template>
            </xsl:when>
            <xsl:otherwise/>
          </xsl:choose>

    		</xsl:when>
        <xsl:otherwise/>
      </xsl:choose>

  	</table>
	</xsl:template>


	<!-- *************** Step FT (function test) ***************************** -->
	<xsl:template match="STEP_FT">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- Good time -->
        <xsl:with-param name="ParamName">Good time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="GoodTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U nom -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

			<!-- <xsl:apply-templates select="Umode"/> -->
			
 			<xsl:call-template name="ShowRealValue">  <!-- I min -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imin"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I max -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imax"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I real -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ireal"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U real -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ureal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

  		<xsl:apply-templates select="GoodTimeOk"/>
  		<xsl:apply-templates select="ErrCode[. > 0]"/>
  	</table>
	</xsl:template>
	
	
	<!-- *************** Step H1 (high voltage test) ************************* -->
	<xsl:template match="STEP_H1">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="Imin_in_mA"/>
 			
 			<xsl:call-template name="ShowRealValue">  <!-- I max -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imax"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U nom -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

			<xsl:call-template name="ConnType"/>
			<xsl:apply-templates select="SkMode"/>

 			<xsl:call-template name="ShowRealValue">  <!-- U real -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ureal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I real -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ireal"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="ErrCode[. > 0]"/>
  	</table>
	</xsl:template>


	<!-- *************** Step H2 (high voltage test) ************************* -->
	<xsl:template match="STEP_H2">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- Ramp time -->
        <xsl:with-param name="ParamName">Ramp time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="RampTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="RampDown"/>

 			<xsl:call-template name="ShowRealValue">  <!-- U start -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">start</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ustart"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U nom -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- IR min -->
        <xsl:with-param name="ParamName">IR</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="IRmin"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- IR max -->
        <xsl:with-param name="ParamName">IR</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="IRmax"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

			<xsl:call-template name="Imin_in_mA"/>

 			<xsl:call-template name="ShowRealValue">  <!-- I max -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imax"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="RampErr"/>
			<xsl:apply-templates select="Method"/>
			<xsl:call-template name="ConnType"/>
			<xsl:apply-templates select="SkMode"/>

 			<xsl:call-template name="ShowRealValue">  <!-- U real -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ureal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I real -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ireal"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

  		<xsl:apply-templates select="ErrCode[. > 0]"/>
  	</table>
	</xsl:template>
	
	
	<!-- *************** Step H3 (high voltage test) ************************* -->
	<xsl:template match="STEP_H3">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- Ramp time -->
        <xsl:with-param name="ParamName">Ramp time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="RampTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="RampDown"/>
			
 			<xsl:call-template name="ShowRealValue">  <!-- U start -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">start</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ustart"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U nom -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U min -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Umin"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U max -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Umax"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- IR min -->
        <xsl:with-param name="ParamName">IR</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="IRmin"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- IR max -->
        <xsl:with-param name="ParamName">IR</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="IRmax"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I min -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imin"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I max -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imax"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="Utype"/>
			<xsl:apply-templates select="Itype"/>
			<xsl:apply-templates select="RampErr"/>
			<xsl:call-template name="TestType"/>
			<xsl:apply-templates select="SkMode"/>
			
 			<xsl:call-template name="ShowRealValue">  <!-- U real -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ureal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>


 			<xsl:call-template name="ShowRealValue">  <!-- I real -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ireal"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="ErrCode[. > 0]"/>
  	</table>
	</xsl:template>


	<!-- *************** Step H4 (high voltage test) ************************* -->
	<xsl:template match="STEP_H4">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- Ramp time -->
        <xsl:with-param name="ParamName">Ramp time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="RampTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="RampDown"/>

 			<xsl:call-template name="ShowRealValue">  <!-- U start -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">start</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ustart"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U nom -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U min -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Umin"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U max -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Umax"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- IR min -->
        <xsl:with-param name="ParamName">IR</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="IRmin"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- IR max -->
        <xsl:with-param name="ParamName">IR</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="IRmax"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I min -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imin"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I max -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imax"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="Utype"/>
			<xsl:apply-templates select="Itype"/>
			<xsl:apply-templates select="RampErr"/>
			<xsl:call-template name="TestType"/>
			<xsl:apply-templates select="SkMode"/>

 			<xsl:call-template name="ShowRealValue">  <!-- U real -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ureal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I real -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ireal"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="ErrCode[. > 0]"/>
    </table>
	</xsl:template>


	<!-- *************** Step H5 (high voltage test) ************************* -->
	<xsl:template match="STEP_H5">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- Ramp time -->
        <xsl:with-param name="ParamName">Ramp time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="RampTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="RampDown"/>

 			<xsl:call-template name="ShowRealValue">  <!-- U start -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">start</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ustart"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U nom -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I min -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imin"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I max -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imax"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="Utype"/>
			<xsl:apply-templates select="Itype"/>
			<xsl:apply-templates select="RampErr"/>
			<xsl:apply-templates select="SkMode"/>

 			<xsl:call-template name="ShowRealValue">  <!-- U real -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ureal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I real -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ireal"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="ErrCode[. > 0]"/>
    </table>
	</xsl:template>


	<!-- *************** Step HA (high voltage test) ************************* -->
	<xsl:template match="STEP_HA">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- Ramp time -->
        <xsl:with-param name="ParamName">Ramp time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="RampTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="IsMotor"/>
			<xsl:apply-templates select="RampDown"/>

 			<xsl:call-template name="ShowRealValue">  <!-- U nom -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U min -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Umin"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U max -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Umax"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I min -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imin"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I max -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imax"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="Utype"/>
			<xsl:apply-templates select="StartMode"/>
			
 			<xsl:call-template name="ShowRealValue">  <!-- U real -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ureal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I real -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ireal"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="ErrCode[. > 0]"/>
  	</table>
	</xsl:template>


	<!-- *************** Step HD (high voltage test) ************************* -->
	<xsl:template match="STEP_HD">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U nom -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I min -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imin"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I max -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imax"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

			<xsl:call-template name="ConnType"/>

 			<xsl:call-template name="ShowRealValue">  <!-- U real -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ureal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I real -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ireal"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="ErrCode[. > 0]"/>
  	</table>
	</xsl:template>


	<!-- *************** Step HH (high voltage test) ************************* -->
	<xsl:template match="STEP_HH">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- Ramp time -->
        <xsl:with-param name="ParamName">Ramp time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="RampTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="RampDown"/>

 			<xsl:call-template name="ShowRealValue">  <!-- U start -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">start</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ustart"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U nom -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U min -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Umin"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U max -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Umax"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I min -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imin"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I max -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imax"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I ramp -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">ramp</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Iramp"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="Utype"/>
			<xsl:apply-templates select="Itype"/>
			<xsl:call-template name="TestType"/>
			<xsl:apply-templates select="StartMode"/>
			
      <xsl:choose>
        <xsl:when test="IrampType = 1">
          <td class="resname">I ramp type&nbsp;:</td>
          <td><span id="IrampType">no</span></td>
        </xsl:when>
        
        <xsl:when test="IrampType = 2">
          <td class="resname">I ramp type&nbsp;:</td>
          <td><span id="IrampType">yes</span></td>
 			    <xsl:call-template name="ShowRealValue">  <!-- I ramp -->
            <xsl:with-param name="ParamName">I</xsl:with-param>
            <xsl:with-param name="ParamIndex">ramp</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="Iramp"/>
            <xsl:with-param name="ParamUnit">A</xsl:with-param>
          </xsl:call-template>
        </xsl:when>

        <xsl:when test="IrampType = 3">
          <td class="resname">I ramp type&nbsp;:</td>
          <td><span id="IrampType">MBE</span></td>
        </xsl:when>

        <xsl:otherwise/>
      </xsl:choose>

 			<xsl:call-template name="ShowRealValue">  <!-- U gen -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">gen</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ugen"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U real -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ureal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I real -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ireal"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="ErrCode[. > 0]"/>
  	</table>
	</xsl:template>


	<!-- *************** Step HS (high voltage test) ************************* -->
	<xsl:template match="STEP_HS">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- Ramp time -->
        <xsl:with-param name="ParamName">Ramp time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="RampTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U nom -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I min -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imin"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I max -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imax"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="VoltMeas"/>
			<xsl:apply-templates select="StartMode"/>
			<!-- <xsl:apply-templates select="TestType"/> -->

 			<xsl:call-template name="ShowRealValue">  <!-- U real -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ureal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I real -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ireal"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="ErrCode[. > 0]"/>
  	</table>
	</xsl:template>


	<!-- *************** Step I1 (insulation test) *************************** -->
	<xsl:template match="STEP_I1">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U nom -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R min -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rmin"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

      <xsl:call-template name="ConnType"/>
      <xsl:apply-templates select="SkMode"/>

 			<xsl:call-template name="ShowRealValue">  <!-- U real -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ureal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R real -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rreal"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="ErrCode[. > 0]"/>
  	</table>
	</xsl:template>


	<!-- *************** Step I2 (insulation test) *************************** -->
	<xsl:template match="STEP_I2">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- Ramp time -->
        <xsl:with-param name="ParamName">Ramp time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="RampTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

      <xsl:apply-templates select="RampDown"/>
      
 			<xsl:call-template name="ShowRealValue">  <!-- U start -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">start</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ustart"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U nom -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R min -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rmin"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

      <xsl:choose>
        <xsl:when test="RampErr = 1">
          <td class="resname">Ramp error&nbsp;:</td>
          <td><span id="IrampType">extra</span></td>

 			    <xsl:call-template name="ShowRealValue">  <!-- IR min -->
            <xsl:with-param name="ParamName">IR</xsl:with-param>
            <xsl:with-param name="ParamIndex">min</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="IRmin"/>
            <xsl:with-param name="ParamUnit">A</xsl:with-param>
          </xsl:call-template>

 			    <xsl:call-template name="ShowRealValue">  <!-- IR max -->
            <xsl:with-param name="ParamName">IR</xsl:with-param>
            <xsl:with-param name="ParamIndex">max</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="IRmax"/>
            <xsl:with-param name="ParamUnit">A</xsl:with-param>
          </xsl:call-template>
        </xsl:when>

        <xsl:when test="RampErr = 2">
          <td class="resname">Ramp error&nbsp;:</td>
          <td><span id="IrampType">MBE</span></td>
        </xsl:when>

        <xsl:otherwise/>
      </xsl:choose>

      <xsl:call-template name="ConnType"/>
      <xsl:apply-templates select="SkMode"/>
      
      <xsl:choose>
        <xsl:when test="PItest = true">

 			    <xsl:call-template name="ShowRealValue">  <!-- PI min -->
            <xsl:with-param name="ParamName">PI</xsl:with-param>
            <xsl:with-param name="ParamIndex">min</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="PImin"/>
            <xsl:with-param name="ParamUnit">%</xsl:with-param>
          </xsl:call-template>

 			    <xsl:call-template name="ShowRealValue">  <!-- PI min -->
            <xsl:with-param name="ParamName">PI</xsl:with-param>
            <xsl:with-param name="ParamIndex">min</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="PImax"/>
            <xsl:with-param name="ParamUnit">%</xsl:with-param>
          </xsl:call-template>

 			    <xsl:call-template name="ShowRealValue">  <!-- PI real -->
            <xsl:with-param name="ParamName">PI</xsl:with-param>
            <xsl:with-param name="ParamIndex">real</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="PIreal"/>
            <xsl:with-param name="ParamUnit">%</xsl:with-param>
          </xsl:call-template>
        </xsl:when>

        <xsl:otherwise/>
      </xsl:choose>

      <xsl:choose>
        <xsl:when test="DARtest = true">

 			    <xsl:call-template name="ShowRealValue">  <!-- DAR min -->
            <xsl:with-param name="ParamName">DAR</xsl:with-param>
            <xsl:with-param name="ParamIndex">min</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="DARmin"/>
            <xsl:with-param name="ParamUnit">%</xsl:with-param>
          </xsl:call-template>

 			    <xsl:call-template name="ShowRealValue">  <!-- DAR min -->
            <xsl:with-param name="ParamName">DAR</xsl:with-param>
            <xsl:with-param name="ParamIndex">min</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="DARmax"/>
            <xsl:with-param name="ParamUnit">%</xsl:with-param>
          </xsl:call-template>

 			    <xsl:call-template name="ShowRealValue">  <!-- DAR real -->
            <xsl:with-param name="ParamName">DAR</xsl:with-param>
            <xsl:with-param name="ParamIndex">real</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="DARreal"/>
            <xsl:with-param name="ParamUnit">%</xsl:with-param>
          </xsl:call-template>
        </xsl:when>

        <xsl:otherwise/>
      </xsl:choose>


 			<xsl:call-template name="ShowRealValue">  <!-- U real -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ureal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R real -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rreal"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="ErrCode[. > 0]"/>
  	</table>
	</xsl:template>
	
	
	<!-- *************** Step I3 (insulation test) *************************** -->
	<xsl:template match="STEP_I3">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- Ramp time -->
        <xsl:with-param name="ParamName">Ramp time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="RampTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

      <xsl:apply-templates select="RampDown"/>

 			<xsl:call-template name="ShowRealValue">  <!-- U start -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">start</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ustart"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U nom -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U min -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Umin"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U max -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Umax"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R min -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rmin"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

      <xsl:choose>
        <xsl:when test="RampErr = 1">
          <td class="resname">Ramp error&nbsp;:</td>
          <td><span id="IrampType">extra</span></td>
        </xsl:when>

        <xsl:when test="RampErr = 2">
          <td class="resname">Ramp error&nbsp;:</td>
          <td><span id="IrampType">MBE</span></td>
        </xsl:when>

        <xsl:otherwise/>
      </xsl:choose>

      <xsl:call-template name="TestType"/>
      <xsl:apply-templates select="SkMode"/>
      
 			<xsl:call-template name="ShowRealValue">  <!-- U real -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ureal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R real -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rreal"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="ErrCode[. > 0]"/>
  	</table>
	</xsl:template>


	<!-- *************** Step I4 (insulation test) *************************** -->
	<xsl:template match="STEP_I4">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- Ramp time -->
        <xsl:with-param name="ParamName">Ramp time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="RampTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

      <xsl:apply-templates select="RampDown"/>

 			<xsl:call-template name="ShowRealValue">  <!-- U start -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">start</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ustart"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U nom -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U min -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Umin"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U max -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Umax"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R min -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rmin"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

      <xsl:choose>
        <xsl:when test="RampErr = 1">
          <td class="resname">Ramp error&nbsp;:</td>
          <td><span id="IrampType">extra</span></td>
        </xsl:when>

        <xsl:when test="RampErr = 2">
          <td class="resname">Ramp error&nbsp;:</td>
          <td><span id="IrampType">MBE</span></td>
        </xsl:when>

        <xsl:otherwise/>
      </xsl:choose>

      <xsl:apply-templates select="SkMode"/>

 			<xsl:call-template name="ShowRealValue">  <!-- U real -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ureal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R real -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rreal"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="ErrCode[. > 0]"/>
  	</table>
	</xsl:template>


	<!-- *************** Step I5 (insulation test) *************************** -->
	<xsl:template match="STEP_I5">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- Ramp time -->
        <xsl:with-param name="ParamName">Ramp time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="RampTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

      <xsl:apply-templates select="RampDown"/>

 			<xsl:call-template name="ShowRealValue">  <!-- U start -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">start</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ustart"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U nom -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U min -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Umin"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U max -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Umax"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R min -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rmin"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

      <xsl:choose>
        <xsl:when test="RampErr = 1">
          <td class="resname">Ramp error&nbsp;:</td>
          <td><span id="IrampType">extra</span></td>
        </xsl:when>

        <xsl:when test="RampErr = 2">
          <td class="resname">Ramp error&nbsp;:</td>
          <td><span id="IrampType">MBE</span></td>
        </xsl:when>

        <xsl:otherwise/>
      </xsl:choose>

      <xsl:apply-templates select="SkMode"/>

 			<xsl:call-template name="ShowRealValue">  <!-- U real -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ureal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R real -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rreal"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="ErrCode[. > 0]"/>
  	</table>
	</xsl:template>


	<!-- *************** Step IS (insulation test) *************************** -->
	<xsl:template match="STEP_IS">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- Ramp time -->
        <xsl:with-param name="ParamName">Ramp time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="RampTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U nom -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R min -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rmin"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

<!--
      <StartMode>1</StartMode>
      <TestType>1</TestType>
-->

 			<xsl:call-template name="ShowRealValue">  <!-- U real -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ureal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I real -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ireal"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R real -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rreal"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="ErrCode[. > 0]"/>
  	</table>
	</xsl:template>


	<!-- *************** Step IT (insulation test) *************************** -->
	<xsl:template match="STEP_IT">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U nom -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R min -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rmin"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

      <xsl:call-template name="ConnType"/>
      
 			<xsl:call-template name="ShowRealValue">  <!-- U real -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ureal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R real -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rreal"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

  	</table>
	</xsl:template>


	<!-- *************** Step L1 (leakage current test) ********************** -->
	<xsl:template match="STEP_L1">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U nom -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I max -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imax"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U real -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ureal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I real -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ireal"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="ErrCode[. > 0]"/>
  	</table>
	</xsl:template>


	<!-- *************** Step LC (leakage current test) ********************** -->
	<xsl:template match="STEP_LC">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U nom -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I max -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imax"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="AI_method"/>

 			<xsl:call-template name="ShowRealValue">  <!-- U real -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ureal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I real -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ireal"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="ErrCode[. > 0]"/>
  	</table>
	</xsl:template>


	<!-- *************** Step PW (protective wire test) ********************** -->
	<xsl:template match="STEP_PW">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- I min -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Imin"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

      <xsl:choose>
        <xsl:when test="Method = 1">
          <td class="resname">Method&nbsp;:</td>
          <td><span id="Method">Resistance</span></td>

 			    <xsl:call-template name="ShowRealValue">  <!-- U max -->
            <xsl:with-param name="ParamName">U</xsl:with-param>
            <xsl:with-param name="ParamIndex">max</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="Umax"/>
            <xsl:with-param name="ParamUnit">V</xsl:with-param>
          </xsl:call-template>

 			    <xsl:call-template name="ShowRealValue">  <!-- R min -->
            <xsl:with-param name="ParamName">R</xsl:with-param>
            <xsl:with-param name="ParamIndex">min</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="Rmin"/>
            <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
          </xsl:call-template>

 			    <xsl:call-template name="ShowRealValue">  <!-- R max -->
            <xsl:with-param name="ParamName">R</xsl:with-param>
            <xsl:with-param name="ParamIndex">max</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="Rmax"/>
            <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
          </xsl:call-template>
        </xsl:when>

        <xsl:when test="Method = 2">
          <td class="resname">Method&nbsp;:</td>
          <td><span id="Method">Voltage</span></td>
          
 			    <xsl:call-template name="ShowRealValue">  <!-- U drop max -->
            <xsl:with-param name="ParamName">U</xsl:with-param>
            <xsl:with-param name="ParamIndex">drop</xsl:with-param>
            <xsl:with-param name="ParamAdd">max</xsl:with-param>
            <xsl:with-param name="ParamValue" select="UdropMax"/>
            <xsl:with-param name="ParamUnit">V</xsl:with-param>
          </xsl:call-template>

        </xsl:when>

        <xsl:otherwise/>
      </xsl:choose>
      
      <xsl:call-template name="PW_StartMode"/>

      <xsl:choose>
        <xsl:when test="FastPW = 'True'">
          <td class="resname">Fast PW&nbsp;</td>

 			    <xsl:call-template name="ShowRealValue">  <!-- PWM -->
            <xsl:with-param name="ParamName">PWM</xsl:with-param>
            <xsl:with-param name="ParamIndex"></xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="PWMset"/>
            <xsl:with-param name="ParamUnit"></xsl:with-param>
          </xsl:call-template>
        </xsl:when>

        <xsl:otherwise/>
      </xsl:choose>

 			<xsl:call-template name="ShowRealValue">  <!-- I real -->
        <xsl:with-param name="ParamName">I</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ireal"/>
        <xsl:with-param name="ParamUnit">A</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R real -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rreal"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U real -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">drop</xsl:with-param>
        <xsl:with-param name="ParamAdd">real</xsl:with-param>
        <xsl:with-param name="ParamValue" select="UdropReal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="ErrCode[. > 0]"/>
  	</table>
	</xsl:template>


	<!-- *************** Step R3 (3-phase test with DU) ******************* -->
	<xsl:template match="STEP_R3">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R min -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rmin"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R max -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rmax"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R diff. max -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">diff.</xsl:with-param>
        <xsl:with-param name="ParamAdd">max</xsl:with-param>
        <xsl:with-param name="ParamValue" select="RdiffMax"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

      <xsl:choose>
        <xsl:when test="DeviceType = 1">
          <tr valign="top">
          <td class="resname">Device&nbsp;:</td>
          <td><span id="DeviceType">3-wires</span></td>
          </tr>
        </xsl:when>

        <xsl:when test="DeviceType = 2">
          <tr valign="top">
          <td class="resname">Device&nbsp;:</td>
          <td><span id="DeviceType">6-wires</span></td>
          </tr>
        </xsl:when>

        <xsl:otherwise/>
      </xsl:choose>

      <xsl:choose>
        <xsl:when test="TempCorr = 'False'">
          <tr valign="top">
          <td class="resname">Temp. correction&nbsp;:</td>
          <td><span id="DeviceType">no</span></td>
          </tr>
        </xsl:when>

        <xsl:when test="TempCorr = 'True'">
          <tr valign="top">
          <td class="resname">Temp. correction&nbsp;:</td>
          <td><span id="DeviceType">yes</span></td>

 			    <xsl:call-template name="ShowRealValue">  <!-- Norm. temp. -->
            <xsl:with-param name="ParamName">Norm. temperature</xsl:with-param>
            <xsl:with-param name="ParamIndex"></xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="NormTemp"/>
            <xsl:with-param name="ParamUnit">C</xsl:with-param>
          </xsl:call-template>

 			    <xsl:call-template name="ShowRealValue">  <!-- Real temp. -->
            <xsl:with-param name="ParamName">Real temperature</xsl:with-param>
            <xsl:with-param name="ParamIndex"></xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="TempReal"/>
            <xsl:with-param name="ParamUnit">C</xsl:with-param>
          </xsl:call-template>
          </tr>
        </xsl:when>

        <xsl:otherwise/>
      </xsl:choose>

      <xsl:choose>
        <xsl:when test="DeviceType = 1">
 			    <xsl:call-template name="ShowRealValue">  <!-- R real (L1-L2) -->
            <xsl:with-param name="ParamName">R</xsl:with-param>
            <xsl:with-param name="ParamIndex">real</xsl:with-param>
            <xsl:with-param name="ParamAdd">(L1-L2)</xsl:with-param>
            <xsl:with-param name="ParamValue" select="Rreal12"/>
            <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
          </xsl:call-template>

 			    <xsl:call-template name="ShowRealValue">  <!-- R real (L2-L3) -->
            <xsl:with-param name="ParamName">R</xsl:with-param>
            <xsl:with-param name="ParamIndex">real</xsl:with-param>
            <xsl:with-param name="ParamAdd">(L2-L3)</xsl:with-param>
            <xsl:with-param name="ParamValue" select="Rreal23"/>
            <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
          </xsl:call-template>

 			    <xsl:call-template name="ShowRealValue">  <!-- R real (L1-L3) -->
            <xsl:with-param name="ParamName">R</xsl:with-param>
            <xsl:with-param name="ParamIndex">real</xsl:with-param>
            <xsl:with-param name="ParamAdd">(L2-L3)</xsl:with-param>
            <xsl:with-param name="ParamValue" select="Rreal31"/>
            <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
          </xsl:call-template>
        </xsl:when>

        <xsl:when test="DeviceType = 2">
 			    <xsl:call-template name="ShowRealValue">  <!-- R real (U-V) -->
            <xsl:with-param name="ParamName">R</xsl:with-param>
            <xsl:with-param name="ParamIndex">real</xsl:with-param>
            <xsl:with-param name="ParamAdd">(U-V)</xsl:with-param>
            <xsl:with-param name="ParamValue" select="Rreal12"/>
            <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
          </xsl:call-template>

 			    <xsl:call-template name="ShowRealValue">  <!-- R real (V-W) -->
            <xsl:with-param name="ParamName">R</xsl:with-param>
            <xsl:with-param name="ParamIndex">real</xsl:with-param>
            <xsl:with-param name="ParamAdd">(V-W)</xsl:with-param>
            <xsl:with-param name="ParamValue" select="Rreal23"/>
            <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
          </xsl:call-template>

 			    <xsl:call-template name="ShowRealValue">  <!-- R real (U-W) -->
            <xsl:with-param name="ParamName">R</xsl:with-param>
            <xsl:with-param name="ParamIndex">real</xsl:with-param>
            <xsl:with-param name="ParamAdd">(U-W)</xsl:with-param>
            <xsl:with-param name="ParamValue" select="Rreal31"/>
            <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
          </xsl:call-template>
        </xsl:when>

        <xsl:otherwise/>
      </xsl:choose>

 			<xsl:call-template name="ShowRealValue">  <!-- R diff. real -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">diff.</xsl:with-param>
        <xsl:with-param name="ParamAdd">real</xsl:with-param>
        <xsl:with-param name="ParamValue" select="RdiffReal"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>
  	</table>
	</xsl:template>


	<!-- *************** Step R5 (resistance test with DU) ******************* -->
	<xsl:template match="STEP_R5">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>
			
 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R min -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rmin"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R max -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rmax"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

      <xsl:choose>
        <xsl:when test="TempMeas = 'True'">
          <tr valign="top">
          <td class="resname">Temp. measuring</td>
          </tr>
        </xsl:when>

        <xsl:otherwise/>
      </xsl:choose>


      <xsl:choose>
        <xsl:when test="TempCorr = 'False'">
          <tr valign="top">
          <td class="resname">Temp. correction&nbsp;:</td>
          <td><span id="DeviceType">no</span></td>
          </tr>
        </xsl:when>

        <xsl:when test="TempCorr = 'True'">
          <tr valign="top">
          <td class="resname">Temp. correction&nbsp;:</td>
          <td><span id="DeviceType">yes</span></td>

 			    <xsl:call-template name="ShowRealValue">  <!-- Norm. temp. -->
            <xsl:with-param name="ParamName">Norm. temperature</xsl:with-param>
            <xsl:with-param name="ParamIndex"></xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="NormTemp"/>
            <xsl:with-param name="ParamUnit">C</xsl:with-param>
          </xsl:call-template>

 			    <xsl:call-template name="ShowRealValue">  <!-- Real temp. -->
            <xsl:with-param name="ParamName">Real temperature</xsl:with-param>
            <xsl:with-param name="ParamIndex"></xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="Treal"/>
            <xsl:with-param name="ParamUnit">C</xsl:with-param>
          </xsl:call-template>
          </tr>
        </xsl:when>

        <xsl:otherwise/>
      </xsl:choose>

 			<xsl:call-template name="ShowRealValue">  <!-- R real -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rreal"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>
  	</table>
	</xsl:template>
	
	
	<!-- *************** Step R6 (resistance test with DU) ******************* -->
	<xsl:template match="STEP_R6">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R min -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rmin"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R max -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rmax"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- L min -->
        <xsl:with-param name="ParamName">L</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Lmin"/>
        <xsl:with-param name="ParamUnit">H</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- L max -->
        <xsl:with-param name="ParamName">L</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Lmax"/>
        <xsl:with-param name="ParamUnit">H</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R real -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rreal"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- L real -->
        <xsl:with-param name="ParamName">L</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Lreal"/>
        <xsl:with-param name="ParamUnit">H</xsl:with-param>
      </xsl:call-template>
  	</table>
	</xsl:template>


	<!-- *************** Step RA (read analog input test) ******************** -->
	<xsl:template match="STEP_RA">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:apply-templates select="IO_Nr"/>
 			<xsl:apply-templates select="UnitS"/>

	    <xsl:call-template name="ShowRealValue">  <!-- Min value -->
        <xsl:with-param name="ParamName">Min. value</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="MinValue"/>
        <xsl:with-param name="ParamUnit"><xsl:value-of select="UnitS"/></xsl:with-param>
      </xsl:call-template>

	    <xsl:call-template name="ShowRealValue">  <!-- Max value -->
        <xsl:with-param name="ParamName">Max. value</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="MaxValue"/>
        <xsl:with-param name="ParamUnit"><xsl:value-of select="UnitS"/></xsl:with-param>
      </xsl:call-template>

	    <xsl:call-template name="ShowRealValue">  <!-- Real value -->
        <xsl:with-param name="ParamName">Real value</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="RealValue"/>
        <xsl:with-param name="ParamUnit"><xsl:value-of select="UnitS"/></xsl:with-param>
      </xsl:call-template>

  	</table>
	</xsl:template>


	<!-- *************** Step RI (read internal input test) ****************** -->
	<xsl:template match="STEP_RI">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="bit8">  <!-- Int. matrix off -->
        <xsl:with-param name="ParamName">Int. matrix off</xsl:with-param>
        <xsl:with-param name="ParamValue" select="MtxIntOff"/>
      </xsl:call-template>

 			<xsl:call-template name="bit8">  <!-- Int. matrix on -->
        <xsl:with-param name="ParamName">Int. matrix on</xsl:with-param>
        <xsl:with-param name="ParamValue" select="MtxIntOn"/>
      </xsl:call-template>

 			<xsl:call-template name="bit8">  <!-- Int. matrix real -->
        <xsl:with-param name="ParamName">Int. matrix real</xsl:with-param>
        <xsl:with-param name="ParamValue" select="MtxIntReal"/>
      </xsl:call-template>

 			<xsl:call-template name="bit16">  <!-- Ext. matrix off -->
        <xsl:with-param name="ParamName">Ext. matrix off</xsl:with-param>
        <xsl:with-param name="ParamValue" select="MtxExtOff"/>
      </xsl:call-template>

 			<xsl:call-template name="bit16">  <!-- Ext. matrix on -->
        <xsl:with-param name="ParamName">Ext. matrix on</xsl:with-param>
        <xsl:with-param name="ParamValue" select="MtxExtOn"/>
      </xsl:call-template>

 			<xsl:call-template name="bit16">  <!-- Ext. matrix real -->
        <xsl:with-param name="ParamName">Ext. matrix real</xsl:with-param>
        <xsl:with-param name="ParamValue" select="MtxExtReal"/>
      </xsl:call-template>
  	</table>
	</xsl:template>
	
	
	<!-- *************** Step RP (real power test) *************************** -->
	<xsl:template match="STEP_RP" name="STEP_RP">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- Good time -->
        <xsl:with-param name="ParamName">Good time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="GoodTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

      <xsl:apply-templates select="GoodTimeOk"/>

 			<xsl:call-template name="ShowRealValue">  <!-- U nom -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">nom</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Unom"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- P min -->
        <xsl:with-param name="ParamName">P</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Pmin"/>
        <xsl:with-param name="ParamUnit">W</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- P max -->
        <xsl:with-param name="ParamName">P</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Pmax"/>
        <xsl:with-param name="ParamUnit">W</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- P real -->
        <xsl:with-param name="ParamName">P</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Preal"/>
        <xsl:with-param name="ParamUnit">W</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- U real -->
        <xsl:with-param name="ParamName">U</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Ureal"/>
        <xsl:with-param name="ParamUnit">V</xsl:with-param>
      </xsl:call-template>

			<xsl:apply-templates select="ErrCode[. > 0]"/>
  	</table>
	</xsl:template>


	<!-- *************** Step RT (simple resistance test) ******************** -->
	<xsl:template match="STEP_RT">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>
			
 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R min -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">min</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rmin"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R max -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">max</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rmax"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="ShowRealValue">  <!-- R real -->
        <xsl:with-param name="ParamName">R</xsl:with-param>
        <xsl:with-param name="ParamIndex">real</xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="Rreal"/>
        <xsl:with-param name="ParamUnit">&Omega;</xsl:with-param>
      </xsl:call-template>

  	</table>
	</xsl:template>

	
	<!-- *************** Step RX (read external input test) ****************** -->
	<xsl:template match="STEP_RX">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>
			
 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="bit16">  <!-- Matrix off -->
        <xsl:with-param name="ParamName">Matrix off</xsl:with-param>
        <xsl:with-param name="ParamValue" select="MatrixOff"/>
      </xsl:call-template>

 			<xsl:call-template name="bit16">  <!-- Matrix on -->
        <xsl:with-param name="ParamName">Matrix on</xsl:with-param>
        <xsl:with-param name="ParamValue" select="MatrixOn"/>
      </xsl:call-template>

 			<xsl:call-template name="bit16">  <!-- Matrix real -->
        <xsl:with-param name="ParamName">Matrix real</xsl:with-param>
        <xsl:with-param name="ParamValue" select="MatrixReal"/>
      </xsl:call-template>
  	</table>
	</xsl:template>
	

	<!-- *************** Step SA (set analog output test) ******************** -->
	<xsl:template match="STEP_SA">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:apply-templates select="IO_Nr"/>
 			<xsl:apply-templates select="UnitS"/>

	    <xsl:call-template name="ShowRealValue">  <!-- Nom. value -->
        <xsl:with-param name="ParamName">Nom. value</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="NomValue"/>
        <xsl:with-param name="ParamUnit"><xsl:value-of select="UnitS"/></xsl:with-param>
      </xsl:call-template>
  	</table>
	</xsl:template>


	<!-- *************** Step SG (surge test) ******************************** -->
	<xsl:template match="STEP_SG">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>
			
			<xsl:apply-templates select="CompType"/>
			<xsl:call-template name="SG_TestType"/>

			<xsl:choose>
 				<xsl:when test="CompType = 1">  <!-- master curve -->
          <xsl:apply-templates select="McuFileName[string-length(.) > 0]"/>
 				</xsl:when>

 				<xsl:otherwise>                 <!-- double test, 3-phase test -->

          <xsl:call-template name="ShowRealValue">  <!-- Voltage -->
            <xsl:with-param name="ParamName">Voltage</xsl:with-param>
            <xsl:with-param name="ParamIndex"></xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="Voltage"/>
            <xsl:with-param name="ParamUnit">V</xsl:with-param>
          </xsl:call-template>

          <xsl:call-template name="SG_VoltageRange"/>
          
          <xsl:call-template name="ShowRealValue">  <!-- Recording time -->
            <xsl:with-param name="ParamName">Recording time</xsl:with-param>
            <xsl:with-param name="ParamIndex"></xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="RecTime"/>
            <xsl:with-param name="ParamUnit">s</xsl:with-param>
          </xsl:call-template>

          <xsl:apply-templates select="ImpulsNr"/>

        </xsl:otherwise>
 			</xsl:choose>

      <xsl:apply-templates select="SkMode"/>
      
      <xsl:choose>
        <xsl:when test="(TestType mod (2)) - (TestType mod (1))">  <!-- Error area -->
        
          <xsl:choose>
            <xsl:when test="(ErrChannel mod (2)) - (ErrChannel mod (1))">  <!-- Signal channel -->
              <xsl:call-template name="ShowRealValue">  <!-- Error area min -->
                <xsl:with-param name="ParamName">Err. area</xsl:with-param>
                <xsl:with-param name="ParamIndex">min</xsl:with-param>
                <xsl:with-param name="ParamAdd">(signal)</xsl:with-param>
                <xsl:with-param name="ParamValue" select="ErrAreaMin1"/>
                <xsl:with-param name="ParamUnit">%</xsl:with-param>
              </xsl:call-template>

              <xsl:call-template name="ShowRealValue">  <!-- Error area max -->
                <xsl:with-param name="ParamName">Err. area</xsl:with-param>
                <xsl:with-param name="ParamIndex">max</xsl:with-param>
                <xsl:with-param name="ParamAdd">(signal)</xsl:with-param>
                <xsl:with-param name="ParamValue" select="ErrAreaMax1"/>
                <xsl:with-param name="ParamUnit">%</xsl:with-param>
              </xsl:call-template>

              <xsl:call-template name="ShowRealValue">  <!-- Error area real -->
                <xsl:with-param name="ParamName">Err. area</xsl:with-param>
                <xsl:with-param name="ParamIndex">real</xsl:with-param>
                <xsl:with-param name="ParamAdd">(signal)</xsl:with-param>
                <xsl:with-param name="ParamValue" select="ErrAreaReal1"/>
                <xsl:with-param name="ParamUnit">%</xsl:with-param>
              </xsl:call-template>

            </xsl:when>
            <xsl:otherwise></xsl:otherwise>
          </xsl:choose>

          <xsl:choose>
            <xsl:when test="(ErrChannel mod (4)) - (ErrChannel mod (2))">  <!-- Hi-freq. channel -->
              <xsl:call-template name="ShowRealValue">  <!-- Error area min -->
                <xsl:with-param name="ParamName">Err. area</xsl:with-param>
                <xsl:with-param name="ParamIndex">min</xsl:with-param>
                <xsl:with-param name="ParamAdd">(hi-freq)</xsl:with-param>
                <xsl:with-param name="ParamValue" select="ErrAreaMin2"/>
                <xsl:with-param name="ParamUnit">%</xsl:with-param>
              </xsl:call-template>

              <xsl:call-template name="ShowRealValue">  <!-- Error area max -->
                <xsl:with-param name="ParamName">Err. area</xsl:with-param>
                <xsl:with-param name="ParamIndex">max</xsl:with-param>
                <xsl:with-param name="ParamAdd">(hi-freq)</xsl:with-param>
                <xsl:with-param name="ParamValue" select="ErrAreaMax2"/>
                <xsl:with-param name="ParamUnit">%</xsl:with-param>
              </xsl:call-template>

              <xsl:call-template name="ShowRealValue">  <!-- Error area real -->
                <xsl:with-param name="ParamName">Err. area</xsl:with-param>
                <xsl:with-param name="ParamIndex">real</xsl:with-param>
                <xsl:with-param name="ParamAdd">(hi-freq)</xsl:with-param>
                <xsl:with-param name="ParamValue" select="ErrAreaReal2"/>
                <xsl:with-param name="ParamUnit">%</xsl:with-param>
              </xsl:call-template>

            </xsl:when>
            <xsl:otherwise></xsl:otherwise>
          </xsl:choose>

        </xsl:when>  <!-- Error area -->

        
        
        
        <xsl:when test="(TestType mod (4)) - (TestType mod (2))">  <!-- Diff. area analysis -->

          <xsl:call-template name="ShowRealValue">  <!-- Diff. area min -->
            <xsl:with-param name="ParamName">Diff. area</xsl:with-param>
            <xsl:with-param name="ParamIndex">min</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="DiffAreaMin"/>
            <xsl:with-param name="ParamUnit">%</xsl:with-param>
          </xsl:call-template>

          <xsl:call-template name="ShowRealValue">  <!-- Diff. area max -->
            <xsl:with-param name="ParamName">Diff. area</xsl:with-param>
            <xsl:with-param name="ParamIndex">max</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="DiffAreaMax"/>
            <xsl:with-param name="ParamUnit">%</xsl:with-param>
          </xsl:call-template>

          <xsl:call-template name="ShowRealValue">  <!-- Diff. area real -->
            <xsl:with-param name="ParamName">Diff. area</xsl:with-param>
            <xsl:with-param name="ParamIndex">real</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="DiffAreaReal"/>
            <xsl:with-param name="ParamUnit">%</xsl:with-param>
          </xsl:call-template>

        </xsl:when>  <!-- Diff. area analysis -->



        <xsl:when test="(TestType mod (8)) - (TestType mod (4))">  <!-- Damping process -->

          <xsl:call-template name="ShowRealValue">  <!-- Diff. area min -->
            <xsl:with-param name="ParamName">Damping</xsl:with-param>
            <xsl:with-param name="ParamIndex">min</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="DampingMin"/>
            <xsl:with-param name="ParamUnit">%</xsl:with-param>
          </xsl:call-template>

          <xsl:call-template name="ShowRealValue">  <!-- Diff. area max -->
            <xsl:with-param name="ParamName">Damping</xsl:with-param>
            <xsl:with-param name="ParamIndex">max</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="DampingMax"/>
            <xsl:with-param name="ParamUnit">%</xsl:with-param>
          </xsl:call-template>

          <xsl:call-template name="ShowRealValue">  <!-- Diff. area real -->
            <xsl:with-param name="ParamName">Damping</xsl:with-param>
            <xsl:with-param name="ParamIndex">real</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="DampingReal"/>
            <xsl:with-param name="ParamUnit">%</xsl:with-param>
          </xsl:call-template>

        </xsl:when>  <!-- Damping process -->



        <xsl:when test="(TestType mod (16)) - (TestType mod (8))">  <!-- Tolerance band -->
          <xsl:apply-templates select="Envelope"/>

          <xsl:call-template name="ShowRealValue">  <!-- Tolerance max -->
            <xsl:with-param name="ParamName">Tolerance</xsl:with-param>
            <xsl:with-param name="ParamIndex">max</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="TolerMax"/>
            <xsl:with-param name="ParamUnit">%</xsl:with-param>
          </xsl:call-template>

          <xsl:apply-templates select="EvalStart"/>
          <xsl:apply-templates select="EvalEnd"/>

          <xsl:call-template name="ShowRealValue">  <!-- Tolerance real -->
            <xsl:with-param name="ParamName">Tolerance</xsl:with-param>
            <xsl:with-param name="ParamIndex">real</xsl:with-param>
            <xsl:with-param name="ParamAdd"></xsl:with-param>
            <xsl:with-param name="ParamValue" select="TolerReal"/>
            <xsl:with-param name="ParamUnit">%</xsl:with-param>
          </xsl:call-template>
        </xsl:when>  <!-- Tolerance band -->



        <xsl:when test="(TestType mod (32)) - (TestType mod (16))">  <!-- Frequency measuring -->

          <xsl:choose>
            <xsl:when test="FreqValue = 1">

              <xsl:call-template name="ShowRealValue">  <!-- Frequency min -->
                <xsl:with-param name="ParamName">Frequency</xsl:with-param>
                <xsl:with-param name="ParamIndex">min</xsl:with-param>
                <xsl:with-param name="ParamAdd"></xsl:with-param>
                <xsl:with-param name="ParamValue" select="FreqMin"/>
                <xsl:with-param name="ParamUnit">%</xsl:with-param>
              </xsl:call-template>
              <xsl:call-template name="ShowRealValue">  <!-- Frequency max -->
                <xsl:with-param name="ParamName">Frequency</xsl:with-param>
                <xsl:with-param name="ParamIndex">max</xsl:with-param>
                <xsl:with-param name="ParamAdd"></xsl:with-param>
                <xsl:with-param name="ParamValue" select="FreqMax"/>
                <xsl:with-param name="ParamUnit">%</xsl:with-param>
              </xsl:call-template>
              <xsl:call-template name="ShowRealValue">  <!-- Frequency real -->
                <xsl:with-param name="ParamName">Frequency</xsl:with-param>
                <xsl:with-param name="ParamIndex">real</xsl:with-param>
                <xsl:with-param name="ParamAdd"></xsl:with-param>
                <xsl:with-param name="ParamValue" select="FreqReal"/>
                <xsl:with-param name="ParamUnit">%</xsl:with-param>
              </xsl:call-template>

            </xsl:when>
            <xsl:when test="FreqValue = 2">

              <xsl:call-template name="ShowRealValue">  <!-- Frequency min -->
                <xsl:with-param name="ParamName">Frequency</xsl:with-param>
                <xsl:with-param name="ParamIndex">min</xsl:with-param>
                <xsl:with-param name="ParamAdd"></xsl:with-param>
                <xsl:with-param name="ParamValue" select="FreqMin"/>
                <xsl:with-param name="ParamUnit">Hz</xsl:with-param>
              </xsl:call-template>
              <xsl:call-template name="ShowRealValue">  <!-- Frequency max -->
                <xsl:with-param name="ParamName">Frequency</xsl:with-param>
                <xsl:with-param name="ParamIndex">max</xsl:with-param>
                <xsl:with-param name="ParamAdd"></xsl:with-param>
                <xsl:with-param name="ParamValue" select="FreqMax"/>
                <xsl:with-param name="ParamUnit">Hz</xsl:with-param>
              </xsl:call-template>
              <xsl:call-template name="ShowRealValue">  <!-- Frequency real -->
                <xsl:with-param name="ParamName">Frequency</xsl:with-param>
                <xsl:with-param name="ParamIndex">real</xsl:with-param>
                <xsl:with-param name="ParamAdd"></xsl:with-param>
                <xsl:with-param name="ParamValue" select="FreqReal"/>
                <xsl:with-param name="ParamUnit">Hz</xsl:with-param>
              </xsl:call-template>

            </xsl:when>
          </xsl:choose>
          
        </xsl:when>  <!-- Frequency measuring -->



        <xsl:when test="(TestType mod (64)) - (TestType mod (32))">  <!-- Corona -->

          <xsl:choose>
            <xsl:when test="(CorChannel mod (2)) - (CorChannel mod (1))">  <!-- Signal channel -->
              <xsl:call-template name="ShowRealValue">  <!-- Corona min -->
                <xsl:with-param name="ParamName">Corona</xsl:with-param>
                <xsl:with-param name="ParamIndex">min</xsl:with-param>
                <xsl:with-param name="ParamAdd">(signal)</xsl:with-param>
                <xsl:with-param name="ParamValue" select="CoronaMin1"/>
                <xsl:with-param name="ParamUnit">%</xsl:with-param>
              </xsl:call-template>

              <xsl:call-template name="ShowRealValue">  <!-- Corona max -->
                <xsl:with-param name="ParamName">Corona</xsl:with-param>
                <xsl:with-param name="ParamIndex">max</xsl:with-param>
                <xsl:with-param name="ParamAdd">(signal)</xsl:with-param>
                <xsl:with-param name="ParamValue" select="CoronaMax1"/>
                <xsl:with-param name="ParamUnit">%</xsl:with-param>
              </xsl:call-template>

              <xsl:call-template name="ShowRealValue">  <!-- Corona real -->
                <xsl:with-param name="ParamName">Corona</xsl:with-param>
                <xsl:with-param name="ParamIndex">real</xsl:with-param>
                <xsl:with-param name="ParamAdd">(signal)</xsl:with-param>
                <xsl:with-param name="ParamValue" select="CoronaReal1"/>
                <xsl:with-param name="ParamUnit">%</xsl:with-param>
              </xsl:call-template>

            </xsl:when>
            <xsl:otherwise></xsl:otherwise>
          </xsl:choose>

          <xsl:choose>
            <xsl:when test="(CorChannel mod (4)) - (CorChannel mod (2))">  <!-- Hi-freq. channel -->
              <xsl:call-template name="ShowRealValue">  <!-- Corona min -->
                <xsl:with-param name="ParamName">Corona</xsl:with-param>
                <xsl:with-param name="ParamIndex">min</xsl:with-param>
                <xsl:with-param name="ParamAdd">(hi-freq)</xsl:with-param>
                <xsl:with-param name="ParamValue" select="CoronaMin2"/>
                <xsl:with-param name="ParamUnit">%</xsl:with-param>
              </xsl:call-template>

              <xsl:call-template name="ShowRealValue">  <!-- Corona max -->
                <xsl:with-param name="ParamName">Corona</xsl:with-param>
                <xsl:with-param name="ParamIndex">max</xsl:with-param>
                <xsl:with-param name="ParamAdd">(hi-freq)</xsl:with-param>
                <xsl:with-param name="ParamValue" select="CoronaMax2"/>
                <xsl:with-param name="ParamUnit">%</xsl:with-param>
              </xsl:call-template>

              <xsl:call-template name="ShowRealValue">  <!-- Corona real -->
                <xsl:with-param name="ParamName">Corona</xsl:with-param>
                <xsl:with-param name="ParamIndex">real</xsl:with-param>
                <xsl:with-param name="ParamAdd">(hi-freq)</xsl:with-param>
                <xsl:with-param name="ParamValue" select="CoronaReal2"/>
                <xsl:with-param name="ParamUnit">%</xsl:with-param>
              </xsl:call-template>

            </xsl:when>
            <xsl:otherwise></xsl:otherwise>
          </xsl:choose>

        </xsl:when>  <!-- Corona -->



        <xsl:otherwise></xsl:otherwise>
      </xsl:choose>

	  <xsl:call-template name="ShowPicture">
				<xsl:with-param name="PicturePath" select="ImgFileName"/>
			</xsl:call-template>
			
			<xsl:apply-templates select="ImgFileName[string-length(.) > 0]"/>
			<xsl:apply-templates select="XMLfileName[string-length(.) > 0]"/>
			<xsl:apply-templates select="XLSfileName[string-length(.) > 0]"/>

  	</table>
	</xsl:template>


	<!-- *************** Step SO (set internal output test) ****************** -->
	<xsl:template match="STEP_SO">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="bit8">  <!-- Matrix int. off -->
        <xsl:with-param name="ParamName">Matrix int. off</xsl:with-param>
        <xsl:with-param name="ParamValue" select="MtxIntOff"/>
      </xsl:call-template>

 			<xsl:call-template name="bit8">  <!-- Matrix int. on -->
        <xsl:with-param name="ParamName">Matrix int. on</xsl:with-param>
        <xsl:with-param name="ParamValue" select="MtxIntOn"/>
      </xsl:call-template>

 			<xsl:call-template name="bit16">  <!-- Matrix ext. off -->
        <xsl:with-param name="ParamName">Matrix ext. off</xsl:with-param>
        <xsl:with-param name="ParamValue" select="MtxExtOff"/>
      </xsl:call-template>

 			<xsl:call-template name="bit16">  <!-- Matrix ext. on -->
        <xsl:with-param name="ParamName">Matrix ext. on</xsl:with-param>
        <xsl:with-param name="ParamValue" select="MtxExtOn"/>
      </xsl:call-template>

  	</table>
	</xsl:template>


	<!-- *************** Step SX (set external output test) ****************** -->
	<xsl:template match="STEP_SX">
		<xsl:call-template name="STPHDR"/>
 		<table border="0">
			<xsl:apply-templates select="MyResult"/>

 			<xsl:call-template name="ShowRealValue">  <!-- Test time -->
        <xsl:with-param name="ParamName">Test time</xsl:with-param>
        <xsl:with-param name="ParamIndex"></xsl:with-param>
        <xsl:with-param name="ParamAdd"></xsl:with-param>
        <xsl:with-param name="ParamValue" select="TestTime"/>
        <xsl:with-param name="ParamUnit">s</xsl:with-param>
      </xsl:call-template>

 			<xsl:call-template name="bit8">  <!-- Matrix off -->
        <xsl:with-param name="ParamName">Matrix off</xsl:with-param>
        <xsl:with-param name="ParamValue" select="MatrixOff"/>
      </xsl:call-template>

 			<xsl:call-template name="bit8">  <!-- Matrix on -->
        <xsl:with-param name="ParamName">Matrix on</xsl:with-param>
        <xsl:with-param name="ParamValue" select="MatrixOn"/>
      </xsl:call-template>

  	</table>
	</xsl:template>
	
	
	<!-- *************** Step TR (protocol information step) ***************** -->
	<xsl:template match="STEP_TR">
	<!--	<xsl:call-template name="STPHDR"/>  -->
   	<table border="0">
 		<!--	<xsl:apply-templates select="MyResult"/>  -->

      <xsl:choose>
        <xsl:when test="Text01 != ''">
          <tr valign="top"><td class="resname"><xsl:value-of select="Text01"/></td></tr>
        </xsl:when>
      </xsl:choose>

      <xsl:choose>
        <xsl:when test="Text02 != ''">
          <tr valign="top"><td class="resname"><xsl:value-of select="Text02"/></td></tr>
        </xsl:when>
      </xsl:choose>

      <xsl:choose>
        <xsl:when test="Text03 != ''">
          <tr valign="top"><td class="resname"><xsl:value-of select="Text03"/></td></tr>
        </xsl:when>
      </xsl:choose>

      <xsl:choose>
        <xsl:when test="Text04 != ''">
          <tr valign="top"><td class="resname"><xsl:value-of select="Text04"/></td></tr>
        </xsl:when>
      </xsl:choose>

      <xsl:choose>
        <xsl:when test="Text05 != ''">
          <tr valign="top"><td class="resname"><xsl:value-of select="Text05"/></td></tr>
        </xsl:when>
      </xsl:choose>

      <xsl:choose>
        <xsl:when test="Text06 != ''">
          <tr valign="top"><td class="resname"><xsl:value-of select="Text06"/></td></tr>
        </xsl:when>
      </xsl:choose>

      <xsl:choose>
        <xsl:when test="Text07 != ''">
          <tr valign="top"><td class="resname"><xsl:value-of select="Text07"/></td></tr>
        </xsl:when>
      </xsl:choose>

      <xsl:choose>
        <xsl:when test="Text08 != ''">
          <tr valign="top"><td class="resname"><xsl:value-of select="Text08"/></td></tr>
        </xsl:when>
      </xsl:choose>

      <xsl:choose>
        <xsl:when test="Text09 != ''">
          <tr valign="top"><td class="resname"><xsl:value-of select="Text09"/></td></tr>
        </xsl:when>
      </xsl:choose>

      <xsl:choose>
        <xsl:when test="Text10 != ''">
          <tr valign="top"><td class="resname"><xsl:value-of select="Text10"/></td></tr>
        </xsl:when>
      </xsl:choose>

		</table>
	</xsl:template>


<!-- *********************************************************************** -->
<!-- ******************************** Templates **************************** -->
<!-- *********************************************************************** -->

	<!-- Inserted to all steps -->
	<xsl:template name="STPHDR">
   <tr>
			<td width="600">
				<span id="Step"># <xsl:number count="*[starts-with(name(),'STEP')]" level="multiple" from="TEST-RESULTS" format="1 "/>
					<xsl:value-of select="substring-after(name(.), 'STEP_')"/> - <xsl:value-of select="StepTitle"/>
				</span>
			</td>
		</tr>
	</xsl:template>
	
	
	
	<!-- Specific values for program header -->
	<xsl:template match="StationID">
   <tr valign="top">
		<td class="resname">Station ID&nbsp;:</td>
		<td>
			<span id="StationID">  <!-- name of identificator for CSS style -->
        <xsl:apply-templates/>
      </span>
    </td>
	 </tr>
	</xsl:template>


	<xsl:template match="ProgramFile">
   <tr valign="top">
		<td class="resname">Program&nbsp;:</td>
		<td>
			<span id="ProgramFile">  <!-- name of identificator for CSS style -->
        <xsl:apply-templates/>
      </span>
    </td>
	 </tr>
	</xsl:template>


	<xsl:template match="TotalResult">
   <tr valign="top">
		<td class="resname">Total result&nbsp;:</td>
		<td>
			<xsl:choose>
				<xsl:when test=". = 1">
					<span id="Passed">PASSED</span>
				</xsl:when>
				<xsl:when test=". = 2">
					<span id="Failed">FAILED</span>
				</xsl:when>
				<xsl:when test=". = 3">
					<span id="Failed">ERROR</span>
				</xsl:when>
				<xsl:when test=". = 4">
					<span id="Failed">BREAK</span>
				</xsl:when>
				<xsl:when test=". = 5">
					<span id="Failed">YES</span>
				</xsl:when>
				<xsl:when test=". = 6">
					<span id="Failed">NO</span>
				</xsl:when>
				<xsl:otherwise>
					<span id="Failed">INVALID</span>
				</xsl:otherwise>
			</xsl:choose>
		</td>
	 </tr>
	</xsl:template>


	<xsl:template match="StartDate">
   <tr valign="top">
	  <td class="resname">Started on&nbsp;:</td>
	  <td>
			<span id="StartDate">  <!-- name of identificator for CSS style -->
	      <xsl:apply-templates/>
      </span>
	  </td>
	 </tr>
	</xsl:template>


	<xsl:template match="EndDate">
   <tr valign="top">
    <td class="resname">Ended on&nbsp;:</td>
	  <td>
			<span id="EndDate">  <!-- name of identificator for CSS style -->
       <xsl:apply-templates/>
      </span>
	  </td>
	 </tr>
	</xsl:template>


	<xsl:template match="Device">
   <tr valign="top">
		<td class="resname">Device&nbsp;:</td>
		<td>
			<span id="DeviceName">
				<xsl:apply-templates/>
			</span>
		</td>
		</tr>
	</xsl:template>
	
	
	<xsl:template match="UserTester">
   <tr valign="top">
		<td class="resname">Tester&nbsp;:</td>
		<td>
			<span id="UserTester">
				<xsl:apply-templates/>
			</span>
		</td>
		</tr>
	</xsl:template>
	
	
	<xsl:template match="SerialNr">
   <tr valign="top">
		<td class="resname">Serial nr.&nbsp;:</td>
  		<td>
  			<span id="SerialNr">
		  		<xsl:apply-templates/>
  			</span>
	  	</td>
		</tr>
	</xsl:template>
	
	
	<xsl:template match="ProductID">
		<tr valign="top">
			<td class="resname">Product ID&nbsp;:</td>
			<td>
  			<span id="ProductID">
		  		<xsl:apply-templates/>
  			</span>
			</td>
		</tr>
	</xsl:template>
	
	
	<xsl:template match="Remark">
		<tr valign="top">
			<td class="resname">Remark&nbsp;:</td>
			<td>
  			<span id="Remark">
		  		<xsl:apply-templates/>
  			</span>
			</td>
		</tr>
	</xsl:template>
	
	
	<xsl:template match="Comment1">
		<tr valign="top">
			<td class="resname">Comment 1&nbsp;:</td>
			<td>
  			<span id="Comment">
		  		<xsl:apply-templates/>
  			</span>
			</td>
		</tr>
	</xsl:template>
	
	
	<xsl:template match="Comment2">
		<tr valign="top">
			<td class="resname">Comment 2&nbsp;:</td>
			<td>
  			<span id="Comment">
		  		<xsl:apply-templates/>
  			</span>
			</td>
		</tr>
	</xsl:template>
	
	
	<!-- Specific values for tests (in step header)-->
	<xsl:template match="StepNumber">
    Step number&nbsp;:
    <b>
			<xsl:apply-templates/>
		</b>
		<br/>
	</xsl:template>
	
	

	<xsl:template match="StepTitle">
    Step title&nbsp;:
    <b>
			<xsl:apply-templates/>
		</b>
		<br/>
	</xsl:template>
	
	
	
	<!-- Show result of step -->
	<xsl:template match="MyResult">
	<tr valign="top">
		<td class="resname">Result&nbsp;:</td>
		<td>
			<xsl:choose>
				<xsl:when test=". = 1">
					<span id="Passed">PASSED</span>
				</xsl:when>
				<xsl:when test=". = 2">
					<span id="Failed">FAILED</span>
				</xsl:when>
				<xsl:when test=". = 3">
					<span id="Failed">ERROR</span>
				</xsl:when>
				<xsl:when test=". = 4">
					<span id="Failed">BREAK</span>
				</xsl:when>
				<xsl:when test=". = 5">
					<span id="Yes">YES</span>
				</xsl:when>
				<xsl:when test=". = 6">
					<span id="No">NO</span>
				</xsl:when>
				<xsl:otherwise>
					<span id="Failed">INVALID</span>
				</xsl:otherwise>
			</xsl:choose>
		</td>
	</tr>
	</xsl:template>
	
	
	
  <xsl:template name="ShowRealValue">
    <xsl:param name="ParamName"></xsl:param>
    <xsl:param name="ParamIndex"></xsl:param>
    <xsl:param name="ParamAdd"></xsl:param>
    <xsl:param name="ParamValue">-1</xsl:param>
    <xsl:param name="ParamUnit">-1</xsl:param>
    <xsl:variable name="ParamValue2" select="$ParamValue[translate(., ',', '.')]"/>

    <tr valign="top">
  		<td class="resname"><xsl:value-of select="$ParamName"/><sub><xsl:value-of select="$ParamIndex"/></sub>&nbsp;<xsl:value-of select="$ParamAdd"/>&nbsp;:</td>
    	<td>

		  	<xsl:choose>

  				<xsl:when test="translate($ParamValue2,',','.') = -1">
            <span id="resname">?</span>
  				</xsl:when>

  				<xsl:when test="translate($ParamValue2,',','.') = 0">
            <span id="resname"><xsl:value-of select="$ParamValue2"/>&nbsp;<xsl:value-of select="$ParamUnit"/></span>
  				</xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E-12')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E-12'))"/>&nbsp;p<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E-11')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E-11') * 10)"/>&nbsp;p<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E-10')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E-10') * 100)"/>&nbsp;p<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E-09')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E-09'))"/>&nbsp;n<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>
			  <xsl:when test="$ParamValue2[contains(., 'E-9')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E-9'))"/>&nbsp;n<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E-08')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E-08') * 10)"/>&nbsp;n<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>
			  <xsl:when test="$ParamValue2[contains(., 'E-8')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E-8') * 10)"/>&nbsp;n<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E-07')]">
						<span id="resname"><xsl:value-of select="round(100 * number(substring-before(translate($ParamValue2,',','.'), 'E-07')))"/>&nbsp;n<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>
			  <xsl:when test="$ParamValue2[contains(., 'E-7')]">
						<span id="resname"><xsl:value-of select="round(100 * number(substring-before(translate($ParamValue2,',','.'), 'E-7')))"/>&nbsp;n<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E-06')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E-06'))"/>&nbsp;&micro;<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>
			  <xsl:when test="$ParamValue2[contains(., 'E-6')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E-6'))"/>&nbsp;&micro;<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E-05')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E-05') * 10)"/>&nbsp;&micro;<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>
			  <xsl:when test="$ParamValue2[contains(., 'E-5')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E-5') * 10)"/>&nbsp;&micro;<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E-04')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E-04') * 100)"/>&nbsp;&micro;<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>
			  <xsl:when test="$ParamValue2[contains(., 'E-4')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E-4') * 100)"/>&nbsp;&micro;<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E-03')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E-03'))"/>&nbsp;m<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>
			  <xsl:when test="$ParamValue2[contains(., 'E-3')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E-3'))"/>&nbsp;m<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E-02')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E-02') * 10)"/>&nbsp;m<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>
			  <xsl:when test="$ParamValue2[contains(., 'E-2')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E-2') * 10)"/>&nbsp;m<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E-01')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E-01') * 100)"/>&nbsp;m<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>
			  <xsl:when test="$ParamValue2[contains(., 'E-1')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E-1') * 100)"/>&nbsp;m<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E00')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E00'))"/>&nbsp;<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>
			  <xsl:when test="$ParamValue2[contains(., 'E0')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E0'))"/>&nbsp;<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E01')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E01') * 10)"/>&nbsp;<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>
			  <xsl:when test="$ParamValue2[contains(., 'E1')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E1') * 10)"/>&nbsp;<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>
			  <xsl:when test="$ParamValue2[contains(., 'E02')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E02') * 100)"/>&nbsp;<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>
			  <xsl:when test="$ParamValue2[contains(., 'E2')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E2') * 100)"/>&nbsp;<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E03')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E03'))"/>&nbsp;k<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>
			  <xsl:when test="$ParamValue2[contains(., 'E3')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E3'))"/>&nbsp;k<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E04')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E04') * 10)"/>&nbsp;k<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>
			  <xsl:when test="$ParamValue2[contains(., 'E4')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E4') * 10)"/>&nbsp;k<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E05')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E05') * 100)"/>&nbsp;k<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>
			  <xsl:when test="$ParamValue2[contains(., 'E5')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E5') * 100)"/>&nbsp;k<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E06')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E06'))"/>&nbsp;M<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>
			  <xsl:when test="$ParamValue2[contains(., 'E6')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E6'))"/>&nbsp;M<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E07')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E07') * 10)"/>&nbsp;M<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>
			  <xsl:when test="$ParamValue2[contains(., 'E7')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E7') * 10)"/>&nbsp;M<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E08')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E08') * 100)"/>&nbsp;M<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>
			  <xsl:when test="$ParamValue2[contains(., 'E8')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E8') * 100)"/>&nbsp;M<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E09')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E09'))"/>&nbsp;G<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>
			  <xsl:when test="$ParamValue2[contains(., 'E9')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E9'))"/>&nbsp;G<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E10')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E10') * 10)"/>&nbsp;G<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E11')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E11') * 100)"/>&nbsp;G<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E12')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E12'))"/>&nbsp;T<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E13')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E13') * 10)"/>&nbsp;T<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>

			  <xsl:when test="$ParamValue2[contains(., 'E14')]">
						<span id="resname"><xsl:value-of select="number(substring-before(translate($ParamValue2,',','.'), 'E14') * 100)"/>&nbsp;T<xsl:value-of select="$ParamUnit"/></span>
			  </xsl:when>



  				<xsl:when test="(translate($ParamValue2,',','.') &lt; 0.000000001) and (translate($ParamValue2,',','.') > -1)">
  					<span id="resname"><xsl:value-of select="format-number(translate($ParamValue2,',','.') * 1000000000000,'#')"/>&nbsp;p<xsl:value-of select="$ParamUnit"/></span>
  				</xsl:when>

  				<xsl:when test="(translate($ParamValue2,',','.') &lt; 0.000001) and (translate($ParamValue2,',','.') > -1)">
  					<span id="resname"><xsl:value-of select="format-number(translate($ParamValue2,',','.') * 1000000000,'#')"/>&nbsp;n<xsl:value-of select="$ParamUnit"/></span>
  				</xsl:when>

  				<xsl:when test="(translate($ParamValue2,',','.') &lt; 0.001) and (translate($ParamValue2,',','.') > -1)">
  					<span id="resname"><xsl:value-of select="format-number(translate($ParamValue2,',','.') * 1000000,'#')"/>&nbsp;&micro;<xsl:value-of select="$ParamUnit"/></span>
  				</xsl:when>

  				<xsl:when test="(translate($ParamValue2,',','.') &lt; 1) and (translate($ParamValue2,',','.') > -1)">
  					<span id="resname"><xsl:value-of select="format-number(translate($ParamValue2,',','.') * 1000,'#.##')"/>&nbsp;m<xsl:value-of select="$ParamUnit"/></span>
  				</xsl:when>

  				<xsl:when test="(translate($ParamValue2,',','.') >= 1000000000000)">
  					<span id="resname"><xsl:value-of select="format-number(translate($ParamValue2,',','.') div 1000000000000,'#.###')"/>&nbsp;T<xsl:value-of select="$ParamUnit"/></span>
  				</xsl:when>

  				<xsl:when test="(translate($ParamValue2,',','.') >= 1000000000)">
  					<span id="resname"><xsl:value-of select="format-number(translate($ParamValue2,',','.') div 1000000000,'#.###')"/>&nbsp;G<xsl:value-of select="$ParamUnit"/></span>
  				</xsl:when>

  				<xsl:when test="(translate($ParamValue2,',','.') >= 1000000)">
  					<span id="resname"><xsl:value-of select="format-number(translate($ParamValue2,',','.') div 1000000,'#.###')"/>&nbsp;M<xsl:value-of select="$ParamUnit"/></span>
  				</xsl:when>

  				<xsl:when test="(translate($ParamValue2,',','.') >= 1000)">
  					<span id="resname"><xsl:value-of select="format-number(translate($ParamValue2,',','.') div 1000,'#.###')"/>&nbsp;k<xsl:value-of select="$ParamUnit"/></span>
  				</xsl:when>

  				<xsl:otherwise>
            <span id="resname"><xsl:value-of select="format-number(translate($ParamValue2,',','.'),'#.###')"/>&nbsp;<xsl:value-of select="$ParamUnit"/></span>
		  		</xsl:otherwise>
  			</xsl:choose>
  		</td>
  	</tr>
  </xsl:template>


	
  <xsl:template name="bit8">
    <xsl:param name="ParamName"></xsl:param>
    <xsl:param name="ParamValue" select="0"/>

    <tr valign="top">
  		<td class="resname"><xsl:value-of select="$ParamName"/>&nbsp;:</td>
    	<td>
        <xsl:choose>
          <xsl:when test="($ParamValue mod (1 * 2)) - ($ParamValue mod (1))">1</xsl:when>
          <xsl:otherwise>0</xsl:otherwise>
        </xsl:choose>
        
        <xsl:choose>
          <xsl:when test="($ParamValue mod (2 * 2)) - ($ParamValue mod (2))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>
        
        <xsl:choose>
          <xsl:when test="($ParamValue mod (4 * 2)) - ($ParamValue mod (4))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>
        
        <xsl:choose>
          <xsl:when test="($ParamValue mod (8 * 2)) - ($ParamValue mod (8))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>
        
        <xsl:choose>
          <xsl:when test="($ParamValue mod (16 * 2)) - ($ParamValue mod (16))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>
        
        <xsl:choose>
          <xsl:when test="($ParamValue mod (32 * 2)) - ($ParamValue mod (32))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>
        
        <xsl:choose>
          <xsl:when test="($ParamValue mod (64 * 2)) - ($ParamValue mod (64))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>
        
        <xsl:choose>
          <xsl:when test="($ParamValue mod (128 * 2)) - ($ParamValue mod (128))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>
  		</td>
  	</tr>
  </xsl:template>




	<xsl:template name="ShowPicture">
    <xsl:param name="PicturePath"></xsl:param>

    <tr valign="top">
		<img>
		  <xsl:attribute name="src">
		  <xsl:value-of select="$PicturePath"/>
		  </xsl:attribute>
		</img>
  	</tr>
	</xsl:template>




  <xsl:template name="bit16">
    <xsl:param name="ParamName"></xsl:param>
    <xsl:param name="ParamValue" select="0"/>

    <tr valign="top">
  		<td class="resname"><xsl:value-of select="$ParamName"/>&nbsp;:</td>
    	<td>
        <xsl:choose>
          <xsl:when test="($ParamValue mod (1 * 2)) - ($ParamValue mod (1))">1</xsl:when>
          <xsl:otherwise>0</xsl:otherwise>
        </xsl:choose>

        <xsl:choose>
          <xsl:when test="($ParamValue mod (2 * 2)) - ($ParamValue mod (2))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>

        <xsl:choose>
          <xsl:when test="($ParamValue mod (4 * 2)) - ($ParamValue mod (4))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>

        <xsl:choose>
          <xsl:when test="($ParamValue mod (8 * 2)) - ($ParamValue mod (8))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>

        <xsl:choose>
          <xsl:when test="($ParamValue mod (16 * 2)) - ($ParamValue mod (16))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>

        <xsl:choose>
          <xsl:when test="($ParamValue mod (32 * 2)) - ($ParamValue mod (32))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>

        <xsl:choose>
          <xsl:when test="($ParamValue mod (64 * 2)) - ($ParamValue mod (64))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>

        <xsl:choose>
          <xsl:when test="($ParamValue mod (128 * 2)) - ($ParamValue mod (128))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>

        <xsl:choose>
          <xsl:when test="($ParamValue mod (256 * 2)) - ($ParamValue mod (256))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>

        <xsl:choose>
          <xsl:when test="($ParamValue mod (512 * 2)) - ($ParamValue mod (512))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>

        <xsl:choose>
          <xsl:when test="($ParamValue mod (1024 * 2)) - ($ParamValue mod (1024))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>

        <xsl:choose>
          <xsl:when test="($ParamValue mod (2048 * 2)) - ($ParamValue mod (2048))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>

        <xsl:choose>
          <xsl:when test="($ParamValue mod (4096 * 2)) - ($ParamValue mod (4096))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>

        <xsl:choose>
          <xsl:when test="($ParamValue mod (8192 * 2)) - ($ParamValue mod (8192))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>

        <xsl:choose>
          <xsl:when test="($ParamValue mod (16384 * 2)) - ($ParamValue mod (16384))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>

        <xsl:choose>
          <xsl:when test="($ParamValue mod (32768 * 2)) - ($ParamValue mod (32768))">&nbsp;1</xsl:when>
          <xsl:otherwise>&nbsp;0</xsl:otherwise>
        </xsl:choose>
  		</td>
  	</tr>
  </xsl:template>




	<xsl:template match="Answer">
    <tr valign="top">
  		<td class="resname">Answer&nbsp;:</td>
	  	<td>
  			<xsl:choose>
  				<xsl:when test=". = 0">
  					<span id="Answer">None</span>
  				</xsl:when>
  				<xsl:when test=". = 1">
  					<span id="Answer">Yes</span>
  				</xsl:when>
  				<xsl:when test=". = 2">
  					<span id="Answer">No</span>
  				</xsl:when>
  				<xsl:otherwise>
  					<span id="Answer">UNDEFINED</span>(<xsl:value-of select="."/>)
          </xsl:otherwise>
			  </xsl:choose>
  		</td>
  	</tr>
	</xsl:template>




	<xsl:template match="Comment">
		<td class="resname">Comment&nbsp;:</td>
		<td>
			<xsl:apply-templates/>
		</td>
	</xsl:template>
	
	
	

	<xsl:template name="ConnType">
  	<tr valign="top">
  		<td class="resname">Connect&nbsp;:</td>
  		<td>
  			<xsl:choose>
  				<xsl:when test="ConnType = 1">
  					<span id="ConnType">Socket</span>
  				</xsl:when>
  				<xsl:when test="ConnType = 2">
  					<span id="ConnType">Probe</span>
  				</xsl:when>
  				<xsl:when test="ConnType = 3">
  					<span id="ConnType">SK2</span>
  				</xsl:when>
  				<xsl:otherwise>
  				<xsl:choose>
  					<xsl:when test="Connect = 1">
  						<span id="ConnType">Socket</span>
  					</xsl:when>
  					<xsl:when test="Connect = 2">
  						<span id="ConnType">Probe</span>
  					</xsl:when>
  					<xsl:when test="Connect = 3">
  						<span id="ConnType">SK2</span>
  					</xsl:when>
  					<xsl:otherwise>
  						<span id="ConnType">UNDEFINED</span>(<xsl:value-of select="."/>)
          				</xsl:otherwise>
  				</xsl:choose>
          			</xsl:otherwise>
  			</xsl:choose>
  		</td>
  	</tr>
	</xsl:template>


	
	<xsl:template match="Direction">
  	<tr valign="top">
  		<td class="resname">Direction&nbsp;:</td>
  		<td>
  			<xsl:choose>
  				<xsl:when test=". = 1">
  					<span id="Direction">left direction</span>
  				</xsl:when>
  				<xsl:when test=". = 2">
  					<span id="Direction">right direction</span>
  				</xsl:when>
  				<xsl:when test=". = 3">
  					<span id="Direction">no direction, field is still</span>
  				</xsl:when>
  				<xsl:when test=". = 4">
  					<span id="Direction">undefined status of field</span>
  				</xsl:when>
  				<xsl:when test=". = 5">
  					<span id="Direction">sensor error</span>
  				</xsl:when>
  				<xsl:otherwise>
  					<span id="Direction">UNDEFINED</span>(<xsl:value-of select="."/>)
          </xsl:otherwise>
  			</xsl:choose>
  		</td>
  	</tr>
	</xsl:template>
	
	
	
  <xsl:template name="Good_DirReal">
    <tr valign="top">
  		<td class="resname">Direction<sub>real</sub>&nbsp;:</td>
    	<td>
		  	<xsl:choose>
  				<xsl:when test="DirReal = 1">
  					<span id="GoodValue">left direction</span>
  				</xsl:when>
  				<xsl:when test="DirReal = 2">
  					<span id="GoodValue">right direction</span>
  				</xsl:when>
  				<xsl:when test="DirReal = 3">
  					<span id="GoodValue">no direction, field is still</span>
  				</xsl:when>
  				<xsl:when test="DirReal = 4">
  					<span id="GoodValue">undefined status of field</span>
  				</xsl:when>
  				<xsl:when test="DirReal = 5">
  					<span id="GoodValue">sensor error</span>
  				</xsl:when>
  				<xsl:otherwise>
  					<span id="GoodValue">UNDEFINED</span>(<xsl:value-of select="."/>)
          </xsl:otherwise>
  			</xsl:choose>
  		</td>
  	</tr>
  </xsl:template>


  <xsl:template name="Fail_DirReal">
    <tr valign="top">
  		<td class="resname">Direction<sub>real</sub>&nbsp;:</td>
    	<td>
		  	<xsl:choose>
  				<xsl:when test="DirReal = 1">
  					<span id="FailValue">left direction</span>
  				</xsl:when>
  				<xsl:when test="DirReal = 2">
  					<span id="FailValue">right direction</span>
  				</xsl:when>
  				<xsl:when test="DirReal = 3">
  					<span id="FailValue">no direction, field is still</span>
  				</xsl:when>
  				<xsl:when test="DirReal = 4">
  					<span id="FailValue">undefined status of field</span>
  				</xsl:when>
  				<xsl:when test="DirReal = 5">
  					<span id="FailValue">sensor error</span>
  				</xsl:when>
  				<xsl:otherwise>
  					<span id="FailValue">UNDEFINED</span>(<xsl:value-of select="."/>)
          </xsl:otherwise>
  			</xsl:choose>
  		</td>
  	</tr>
  </xsl:template>


	<xsl:template match="Envelope">
  	<tr valign="top">
	  	<td class="resname">Envelope&nbsp;:</td>
		  <td><xsl:apply-templates/></td>
		</tr>
	</xsl:template>
	
	
	
	<xsl:template match="ErrCode">
  	<tr valign="top">
	  	<td class="resname">Error&nbsp;:</td>
  		<td>
	  		<xsl:choose>
				<xsl:when test=". = 100">  <!-- HH test - low voltage -->
  					<span id="ErrorCode">LOW VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 101">  <!-- HH test - high voltage -->
  					<span id="ErrorCode">HIGH VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 102">  <!-- HH test - low current -->
  					<span id="ErrorCode">LOW CURRENT!</span>
  				</xsl:when>
				<xsl:when test=". = 103">  <!-- HH test - high current -->
  					<span id="ErrorCode">HIGH CURRENT!</span>
  				</xsl:when>

				<xsl:when test=". = 110">  <!-- HA test - low voltage -->
  					<span id="ErrorCode">LOW VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 111">  <!-- HA test - high voltage -->
  					<span id="ErrorCode">HIGH VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 112">  <!-- HA test - low current -->
  					<span id="ErrorCode">LOW CURRENT!</span>
  				</xsl:when>
				<xsl:when test=". = 113">  <!-- HA test - high current -->
  					<span id="ErrorCode">HIGH CURRENT!</span>
  				</xsl:when>

				<xsl:when test=". = 120">  <!-- HD test - high current -->
  					<span id="ErrorCode">HIGH CURRENT!</span>
  				</xsl:when>

				<xsl:when test=". = 130">  <!-- HS test - high current -->
  					<span id="ErrorCode">HIGH CURRENT!</span>
  				</xsl:when>
				<xsl:when test=". = 131">  <!-- HS test - no sense voltage -->
  					<span id="ErrorCode">NO SENSE VOLTAGE!</span>
  				</xsl:when>

				<xsl:when test=". = 140">  <!-- IS test - low resistance -->
  					<span id="ErrorCode">LOW RESISTANCE!</span>
  				</xsl:when>

				<xsl:when test=". = 150">  <!-- LC test - high current -->
  					<span id="ErrorCode">HIGH CURRENT!</span>
  				</xsl:when>

				<xsl:when test=". = 160">  <!-- PW test - start timeout -->
  					<span id="ErrorCode">START TIMEOUT!</span>
  				</xsl:when>
				<xsl:when test=". = 161">  <!-- PW test - disconnected -->
  					<span id="ErrorCode">DISCONNECTED!</span>
  				</xsl:when>

				<xsl:when test=". = 170">  <!-- H1 test - low voltage -->
  					<span id="ErrorCode">LOW VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 171">  <!-- H1 test - high voltage -->
  					<span id="ErrorCode">HIGH VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 172">  <!-- H1 test - low current -->
  					<span id="ErrorCode">LOW CURRENT!</span>
  				</xsl:when>
				<xsl:when test=". = 173">  <!-- H1 test - high current -->
  					<span id="ErrorCode">HIGH CURRENT!</span>
  				</xsl:when>
				
				<xsl:when test=". = 180">  <!-- H2 test - low voltage -->
  					<span id="ErrorCode">LOW VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 181">  <!-- H2 test - high voltage -->
  					<span id="ErrorCode">HIGH VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 182">  <!-- H2 test - low current -->
  					<span id="ErrorCode">LOW CURRENT!</span>
  				</xsl:when>
				<xsl:when test=". = 183">  <!-- H2 test - high current -->
  					<span id="ErrorCode">HIGH CURRENT!</span>
  				</xsl:when>
				<xsl:when test=". = 184">  <!-- H2 test - no sense voltage -->
  					<span id="ErrorCode">NO SENSE VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 185">  <!-- H2 test - low ramp current -->
  					<span id="ErrorCode">LOW RAMP CURRENT!</span>
  				</xsl:when>

				<xsl:when test=". = 190">  <!-- H3 test - low voltage -->
  					<span id="ErrorCode">LOW VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 191">  <!-- H3 test - high voltage -->
  					<span id="ErrorCode">HIGH VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 192">  <!-- H3 test - low current -->
  					<span id="ErrorCode">LOW CURRENT!</span>
  				</xsl:when>
				<xsl:when test=". = 193">  <!-- H3 test - high current -->
  					<span id="ErrorCode">HIGH CURRENT!</span>
  				</xsl:when>
				<xsl:when test=". = 194">  <!-- H3 test - low ramp current -->
  					<span id="ErrorCode">LOW RAMP CURRENT!</span>
  				</xsl:when>

				<xsl:when test=". = 200">  <!-- I1 test - low voltage -->
  					<span id="ErrorCode">LOW VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 201">  <!-- I1 test - high voltage -->
  					<span id="ErrorCode">HIGH VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 202">  <!-- I1 test - low resistance -->
  					<span id="ErrorCode">LOW RESISTANCE!</span>
  				</xsl:when>
				<xsl:when test=". = 203">  <!-- I1 test - high resistance -->
  					<span id="ErrorCode">HIGH RESISTANCE!</span>
  				</xsl:when>

				<xsl:when test=". = 210">  <!-- I2 test - low voltage -->
  					<span id="ErrorCode">LOW VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 211">  <!-- I2 test - high voltage -->
  					<span id="ErrorCode">HIGH VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 212">  <!-- I2 test - low resistance -->
  					<span id="ErrorCode">LOW RESISTANCE!</span>
  				</xsl:when>
				<xsl:when test=". = 213">  <!-- I2 test - high resistance -->
  					<span id="ErrorCode">HIGH RESISTANCE!</span>
  				</xsl:when>
				<xsl:when test=". = 214">  <!-- I2 test - wrong voltage -->
  					<span id="ErrorCode">WRONG VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 215">  <!-- I2 test - low ramp current -->
  					<span id="ErrorCode">LOW RAMP CURRENT!</span>
  				</xsl:when>

				<xsl:when test=". = 220">  <!-- AI test - high current -->
  					<span id="ErrorCode">HIGH CURRENT!</span>
  				</xsl:when>

				<xsl:when test=". = 230">  <!-- R5 test - communication error -->
  					<span id="ErrorCode">COMMUNICATION ERROR!</span>
  				</xsl:when>

				<xsl:when test=". = 240">  <!-- FD test - sensor error -->
  					<span id="ErrorCode">SENSOR ERROR!</span>
  				</xsl:when>

				<xsl:when test=". = 250">  <!-- SG test - error during measuring of curve -->
  					<span id="ErrorCode">ERROR DURING MEASURING OF CURVE!</span>
  				</xsl:when>
				<xsl:when test=". = 251">  <!-- SG test - error during loading of master curve from file -->
  					<span id="ErrorCode">ERROR DURING LOADING OF MASTER CURVE FROM FILE!</span>
  				</xsl:when>

				<xsl:when test=". = 260">  <!-- I3 test - low voltage -->
  					<span id="ErrorCode">LOW VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 261">  <!-- I3 test - high voltage -->
  					<span id="ErrorCode">HIGH VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 262">  <!-- I3 test - low resistance -->
  					<span id="ErrorCode">LOW RESISTANCE!</span>
  				</xsl:when>
				<xsl:when test=". = 263">  <!-- I3 test - high resistance -->
  					<span id="ErrorCode">HIGH RESISTANCE!</span>
  				</xsl:when>
				<xsl:when test=". = 264">  <!-- I3 test - wrong voltage -->
  					<span id="ErrorCode">WRONG VOLTAGE!</span>
  				</xsl:when>

				<xsl:when test=". = 270">  <!-- H4 test - low voltage -->
  					<span id="ErrorCode">LOW VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 271">  <!-- H4 test - high voltage -->
  					<span id="ErrorCode">HIGH VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 272">  <!-- H4 test - low current -->
  					<span id="ErrorCode">LOW CURRENT!</span>
  				</xsl:when>
				<xsl:when test=". = 273">  <!-- H4 test - high current -->
  					<span id="ErrorCode">HIGH CURRENT!</span>
  				</xsl:when>
				<xsl:when test=". = 274">  <!-- H4 test - low ramp current -->
  					<span id="ErrorCode">LOW RAMP CURRENT!</span>
  				</xsl:when>

				<xsl:when test=". = 281">  <!-- I4 test - low voltage -->
  					<span id="ErrorCode">LOW VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 282">  <!-- I4 test - high voltage -->
  					<span id="ErrorCode">HIGH VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 283">  <!-- I4 test - low resistance -->
  					<span id="ErrorCode">LOW RESISTANCE!</span>
  				</xsl:when>
				<xsl:when test=". = 284">  <!-- I4 test - high resistance -->
  					<span id="ErrorCode">HIGH RESISTANCE!</span>
  				</xsl:when>
				<xsl:when test=". = 285">  <!-- I4 test - wrong voltage -->
  					<span id="ErrorCode">WRONG VOLTAGE!</span>
  				</xsl:when>

				<xsl:when test=". = 290">  <!-- R6 test - communication error -->
  					<span id="ErrorCode">COMMUNICATION ERROR!</span>
  				</xsl:when>

				<xsl:when test=". = 300">  <!-- IT test - low resistance -->
  					<span id="ErrorCode">LOW RESISTANCE!</span>
  				</xsl:when>

				<xsl:when test=". = 310">  <!-- I5 test - low voltage -->
  					<span id="ErrorCode">LOW VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 311">  <!-- I5 test - high voltage -->
  					<span id="ErrorCode">HIGH VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 312">  <!-- I5 test - low resistance -->
  					<span id="ErrorCode">LOW RESISTANCE!</span>
  				</xsl:when>
				<xsl:when test=". = 313">  <!-- I5 test - high resistance -->
  					<span id="ErrorCode">HIGH RESISTANCE!</span>
  				</xsl:when>
				<xsl:when test=". = 314">  <!-- I5 test - wrong voltage -->
  					<span id="ErrorCode">WRONG VOLTAGE!</span>
  				</xsl:when>

				<xsl:when test=". = 320">  <!-- H5 test - low voltage -->
  					<span id="ErrorCode">LOW VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 321">  <!-- H5 test - high voltage -->
  					<span id="ErrorCode">HIGH VOLTAGE!</span>
  				</xsl:when>
				<xsl:when test=". = 322">  <!-- H5 test - low current -->
  					<span id="ErrorCode">LOW CURRENT!</span>
  				</xsl:when>
				<xsl:when test=". = 323">  <!-- H5 test - high current -->
  					<span id="ErrorCode">HIGH CURRENT!</span>
  				</xsl:when>
				<xsl:when test=". = 324">  <!-- H5 test - low ramp current -->
  					<span id="ErrorCode">LOW RAMP CURRENT!</span>
  				</xsl:when>

				<xsl:when test=". = 330">  <!-- L1 test - high current -->
  					<span id="ErrorCode">HIGH CURRENT!</span>
  				</xsl:when>

  				<xsl:otherwise>
  					<span id="ErrorCode">UNKNOWN ERROR!</span>
          </xsl:otherwise>
  			</xsl:choose>
  		</td>
  	</tr>
	</xsl:template>
	

	<xsl:template match="Method">
  	<tr valign="top">
  		<td class="resname">Method&nbsp;:</td>
  		<td>
  			<xsl:choose>
  				<xsl:when test=". = 1">
  					<span id="Method">source</span>
  				</xsl:when>
  				<xsl:when test=". = 2">
  					<span id="Method">sense</span>
  				</xsl:when>
  				<xsl:when test=". = 99">
  					<span id="Method">none</span>
  				</xsl:when>
  				<xsl:otherwise>
  					<span id="Method">UNDEFINED</span>(<xsl:value-of select="."/>)
          </xsl:otherwise>
  			</xsl:choose>
  		</td>
  	</tr>
	</xsl:template>



	<xsl:template name="PW_method">
  	<tr valign="top">
  		<td class="resname">Method&nbsp;:</td>
  		<td>
  			<xsl:choose>
  				<xsl:when test="Method = 1">
  					<span id="Method">EN60335 (Resistance)</span>
  				</xsl:when>
  				<xsl:when test="Method = 2">
  					<span id="Method">EN60204 (Voltage)</span>
  				</xsl:when>
  				<xsl:otherwise>
  					<span id="Method">UNDEFINED</span>(<xsl:value-of select="."/>)
          </xsl:otherwise>
    		</xsl:choose>
  		</td>
  	</tr>
	</xsl:template>



	<xsl:template name="AI_method">
    <tr valign="top">
  		<td class="resname">Method&nbsp;:</td>
	  	<td>
		  	<xsl:choose>
  				<xsl:when test="Method = 1">
  					<span id="Method">A1</span>
  				</xsl:when>
  				<xsl:when test="Method = 2">
  					<span id="Method">A2</span>
  				</xsl:when>
  				<xsl:when test="Method = 3">
  					<span id="Method">B</span>
  				</xsl:when>
          <xsl:otherwise>
  					<span id="Method">UNDEFINED</span>
          </xsl:otherwise>
  			</xsl:choose>
  		</td>
  	</tr>
	</xsl:template>



	<xsl:template name="VT_method">
    <tr valign="top">
		  <td class="resname">Test type&nbsp;:</td>
		  <td>
			  <xsl:choose>
				  <xsl:when test="TestType = 1">
					  <span id="TestType">info step</span>
				  </xsl:when>
				  <xsl:when test="TestType = 2">
					  <span id="TestType">visual test</span>
				  </xsl:when>
				  <xsl:when test="TestType = 3">
					  <span id="TestType">function test</span>
				  </xsl:when>
				  <xsl:when test="TestType = 4">
					  <span id="TestType">control step</span>
				  </xsl:when>
          <xsl:otherwise>
					  <span id="TestType">UNDEFINED</span>
          </xsl:otherwise>
			  </xsl:choose>
		  </td>
		</tr>
	</xsl:template>



	<xsl:template name="TestType">
    <tr valign="top">
		  <td class="resname">Test mode&nbsp;:</td>
		  <td>
			  <xsl:choose>
				  <xsl:when test="TestType = 1">
					  <span id="TestType">test (t)</span>
				  </xsl:when>
				  <xsl:when test="TestType = 2">
					  <span id="TestType">burn</span>
				  </xsl:when>
				  <xsl:when test="TestType = 3">
					  <span id="TestType">endless</span>
				  </xsl:when>
          <xsl:otherwise>
					  <span id="TestType">UNDEFINED</span>
          </xsl:otherwise>
			  </xsl:choose>
		  </td>
		</tr>
	</xsl:template>



	<xsl:template match="EvalStart">
  	<tr valign="top">
	  	<td class="resname">Evaluation start&nbsp;:</td>
		  <td><xsl:apply-templates/></td>
		</tr>
	</xsl:template>
	
	
	
	<xsl:template match="EvalEnd">
    <tr valign="top">
		  <td class="resname">Evaluation end&nbsp;:</td>
		  <td><xsl:apply-templates/></td>
		</tr>
	</xsl:template>



	<xsl:template match="FastPW">
  	<tr valign="top">
  		<td class="resname">Fast PW&nbsp;:</td>
  		<td><xsl:apply-templates/></td>
  	</tr>
	</xsl:template>
	
	
	
	<xsl:template match="FileName">
	  <tr valign="top">
		  <td class="resname">Filename&nbsp;:</td>
		  <td><a href="{.}"><xsl:apply-templates/></a></td>
		</tr>
	</xsl:template>
	
	
	
	<xsl:template match="FreqValue">
  	<tr valign="top">
	  	<td class="resname">FreqValue&nbsp;:</td>
		  <td><xsl:apply-templates/></td>
		</tr>
	</xsl:template>
	
	
	
	<xsl:template match="GoodTimeOk">
  	<tr valign="top">
  		<td class="resname">Good time Ok&nbsp;:</td>
  		<td>
  			<xsl:choose>
  				<xsl:when test=". = 'True'">
  					<span id="GoodTimeOkPassed">OK</span>
  				</xsl:when>
  				<xsl:when test=". = '1'">
  					<span id="GoodTimeOkPassed">OK</span>
  				</xsl:when>
  				<xsl:otherwise>
  					<span id="GoodTimeOkFailed">FAILED</span>(<xsl:value-of select="."/>)
          			</xsl:otherwise>
  			</xsl:choose>
  		</td>
  	</tr>
	</xsl:template>
	

	
	<xsl:template match="McuFileName">
  	<tr valign="top">
	  	<td class="resname">Master curve&nbsp;:</td>
		  <td><a href="{.}"><xsl:apply-templates/></a></td>
		</tr>
	</xsl:template>



	<xsl:template match="ImgFileName">
  	<tr valign="top">
  		<td class="resname">Picture&nbsp;:</td>
  		<td><a href="{.}"><xsl:apply-templates/></a></td>
  	</tr>
	</xsl:template>
	
	
	
	<xsl:template match="XMLfileName">
  	<tr valign="top">
	  	<td class="resname">Result curve&nbsp;:</td>
  		<td><a href="{.}"><xsl:apply-templates/></a></td>
  	</tr>
	</xsl:template>



	<xsl:template match="XLSfileName">
  	<tr valign="top">
  		<td class="resname">XLS file&nbsp;:</td>
  		<td><a href="{.}"><xsl:apply-templates/></a></td>
  	</tr>
	</xsl:template>



	<xsl:template name="Imin_in_mA">
  	<tr valign="top">
	  	<td class="resname">I<sub>min</sub>&nbsp;:</td>
  		<td><xsl:value-of select="Imin * 1000"/>&nbsp;mA</td>
  	</tr>
	</xsl:template>



	<xsl:template match="ImpulsNr">
  	<tr valign="top">
	  	<td class="resname">Nr. of impulses&nbsp;:</td>
		  <td><xsl:apply-templates/></td>
		</tr>
	</xsl:template>
	
	
	
	<xsl:template match="IO_Nr">
  	<tr valign="top">
  		<td class="resname">Nr. of IO&nbsp;:</td>
  		<td><xsl:apply-templates/></td>
  	</tr>
	</xsl:template>
	
	
	
  <xsl:template name="Good_CosPhiReal">
    <tr valign="top">
  		<td class="resname">cos&nbsp;&phi;<sub>real</sub>&nbsp;:</td>
    	<td><span id="GoodValue"><xsl:value-of select="CosPhiReal"/></span></td>
  	</tr>
  </xsl:template>



  <xsl:template name="Fail_CosPhiReal">
    <tr valign="top">
  		<td class="resname">cos&nbsp;&phi;<sub>real</sub>&nbsp;:</td>
    	<td><span id="FailValue"><xsl:value-of select="CosPhiReal"/></span></td>
  	</tr>
  </xsl:template>



	<xsl:template match="IsMotor">
  	<tr valign="top">
  		<td class="resname">With motor&nbsp;:</td>
  		<td><xsl:apply-templates/></td>
  	</tr>
	</xsl:template>
	
	
	
	<xsl:template match="KeepPower">
  	<tr valign="top">
  		<td class="resname">Keep power&nbsp;:</td>
  		<td><xsl:apply-templates/></td>
  	</tr>
	</xsl:template>
	
	
	
	<xsl:template match="MaxValue">
  	<tr valign="top">
  		<td class="resname">Max. value&nbsp;:</td>
  		<td><xsl:apply-templates/></td>
  	</tr>
	</xsl:template>
	
	
	
	<xsl:template match="OverRange">
  	<tr valign="top">
  		<td class="resname">Overrange&nbsp;:</td>
  		<td><xsl:apply-templates/></td>
  	</tr>
	</xsl:template>
	
	
	
	<xsl:template match="CosPhiMin">
  	<tr valign="top">
  		<td class="resname">cos&nbsp;&phi;<sub>min</sub>&nbsp;:</td>
  		<td><xsl:apply-templates/></td>
  	</tr>
	</xsl:template>



	<xsl:template match="CosPhiMax">
  	<tr valign="top">
  		<td class="resname">cos&nbsp;&phi;<sub>max</sub>&nbsp;:</td>
  		<td><xsl:apply-templates/></td>
  	</tr>
	</xsl:template>



	<xsl:template match="CosPhiReal">
  	<tr valign="top">
  		<td class="resname">cos&nbsp;&phi;<sub>real</sub>&nbsp;:</td>
  		<td><xsl:apply-templates/></td>
  	</tr>
	</xsl:template>



	<xsl:template match="PWMset">
  	<tr valign="top">
  		<td class="resname">PWM set&nbsp;:</td>
  		<td><xsl:apply-templates/></td>
  	</tr>
	</xsl:template>
	
	
	
	<xsl:template match="RampDown">
  	<tr valign="top">
  		<td class="resname">Ramp down&nbsp;:</td>
  		<td>
  			<xsl:choose>
  				<xsl:when test=". = 1">
  					<span id="RampErr">used</span>
  				</xsl:when>
  				<xsl:when test=". = 0">
  					<span id="RampErr">not used</span>
  				</xsl:when>
  				<xsl:when test=". = -1">
  					<span id="RampErr">used</span>
  				</xsl:when>
  				<xsl:when test=". = 'False'">
  					<span id="RampErr">not used</span>
  				</xsl:when>
  				<xsl:when test=". = 'True'">
  					<span id="RampErr">used</span>
  				</xsl:when>
  				<xsl:otherwise>
  					<span id="RampErr">UNDEFINED</span>(<xsl:value-of select="."/>)
          </xsl:otherwise>
  			</xsl:choose>
  		</td>
  	</tr>
	</xsl:template>

	
	
	<xsl:template match="RampErr">
  	<tr valign="top">
  		<td class="resname">Ramp error&nbsp;:</td>
  		<td>
  			<xsl:choose>
  				<xsl:when test=". = 0">
  					<span id="RampErr">No error</span>
  				</xsl:when>
  				<xsl:when test=". = 1">
  					<span id="RampErr">Normal</span>
  				</xsl:when>
  				<xsl:when test=". = 2">
  					<span id="RampErr">Extra</span>
  				</xsl:when>
  				<xsl:when test=". = 3">
  					<span id="RampErr">MBE</span>
  				</xsl:when>
  				<xsl:otherwise>
  					<span id="RampErr">UNDEFINED</span>(<xsl:value-of select="."/>)
          </xsl:otherwise>
  			</xsl:choose>
  		</td>
  	</tr>
	</xsl:template>
	
	
	
	<xsl:template match="SkMode">
  	<tr valign="top">
  		<td class="resname">Safety ctrl.&nbsp;:</td>
  		<td>
  			<xsl:choose>
  				<xsl:when test=". = 1">
  					<span id="SkMode">off</span>
  				</xsl:when>
  				<xsl:when test=". = 2">
  					<span id="SkMode">start impulse</span>
  				</xsl:when>
  				<xsl:when test=". = 3">
  					<span id="SkMode">start and hold</span>
  				</xsl:when>
  				<xsl:when test=". = 4">
  					<span id="SkMode">safety contact</span>
  				</xsl:when>
  				<xsl:when test=". = 5">
  					<span id="SkMode">test pistols</span>
  				</xsl:when>
  				<xsl:otherwise>
  					<span id="SkMode">UNDEFINED</span>(<xsl:value-of select="."/>)
          </xsl:otherwise>
  			</xsl:choose>
  		</td>
  	</tr>
	</xsl:template>
	
	

	<xsl:template name="PW_StartMode">
  	<tr valign="top">
  		<td class="resname">Start mode&nbsp;:</td>
  		<td>
  			<xsl:choose>
  				<xsl:when test="StartMode = 0">
  					<span id="StartMode">Immediately</span>
  				</xsl:when>
  				<xsl:when test="StartMode = 1">
  					<span id="StartMode">Automatical</span>
  				</xsl:when>
  				<xsl:when test="StartMode = 2">
  					<span id="StartMode">Start button</span>
  				</xsl:when>
  				<xsl:when test="StartMode = 3">
  					<span id="StartMode">Immediately</span>
  				</xsl:when>
  				<xsl:otherwise>
  					<span id="StartMode">UNDEFINED</span>(<xsl:value-of select="."/>)
          </xsl:otherwise>
  			</xsl:choose>
  		</td>
  	</tr>
	</xsl:template>



	<xsl:template match="StartMode">
  	<tr valign="top">
  		<td class="resname">Start mode&nbsp;:</td>
  		<td>
  			<xsl:choose>
  				<xsl:when test=". = 1">
  					<span id="StartMode">Immediately</span>
  				</xsl:when>
  				<xsl:when test=". = 2">
  					<span id="StartMode">Start</span>
  				</xsl:when>
  				<xsl:when test=". = 3">
  					<span id="StartMode">Hold</span>
  				</xsl:when>
  				<xsl:otherwise>
  					<span id="StartMode">UNDEFINED</span>(<xsl:value-of select="."/>)
          </xsl:otherwise>
  			</xsl:choose>
  		</td>
  	</tr>
	</xsl:template>



	<xsl:template match="Text">
		<td class="resname">Text&nbsp;:</td>
		<td>
			"<xsl:value-of select="UserText"/>"
		</td>
	</xsl:template>
	
	

	<xsl:template name="Question">
    <tr valign="top">
  	  <td class="resname">Question&nbsp;:</td>
		  <td>
		  "<xsl:value-of select="UserText"/><xsl:value-of select="Text"/>"
		  </td>
		</tr>
	</xsl:template>
	
	

	<xsl:template name="Info">
    <tr valign="top">
		  <td class="resname">Info&nbsp;:</td>
		  <td>"<xsl:value-of select="UserText"/>"</td>
		</tr>
	</xsl:template>
	
	

	<xsl:template match="TolerMax">
  	<tr valign="top">
	  	<td class="resname">Tolerance max.&nbsp;:</td>
		  <td><xsl:apply-templates/></td>
		</tr>
	</xsl:template>
	
	

	<xsl:template match="TolerReal">
  	<tr valign="top">
	  	<td class="resname">Tolerance real&nbsp;:</td>
  		<td><xsl:apply-templates/></td>
  	</tr>
	</xsl:template>
	
	

	<xsl:template match="UnitS">
  	<tr valign="top">
  		<td class="resname">Unit&nbsp;:</td>
  		<td><xsl:apply-templates/></td>
  	</tr>
	</xsl:template>
	
	

	<xsl:template match="AlogUnit1">
		<td class="resname">Analog 1 unit&nbsp;:</td>
		<td>
			<xsl:apply-templates/>
		</td>
	</xsl:template>



	<xsl:template match="AlogUnit2">
		<td class="resname">Analog 2 unit&nbsp;:</td>
		<td>
			<xsl:apply-templates/>
		</td>
	</xsl:template>



  <xsl:template name="GoodValue">
    <xsl:param name="ParamName"></xsl:param>
    <xsl:param name="ParamIndex"></xsl:param>
    <xsl:param name="ParamAdd"></xsl:param>
    <xsl:param name="ParamValue">-1</xsl:param>
    <xsl:param name="ParamUnit">-1</xsl:param>
    <tr valign="top">
  		<td class="resname"><xsl:value-of select="$ParamName"/><sub><xsl:value-of select="$ParamIndex"/></sub>&nbsp;<xsl:value-of select="$ParamAdd"/>&nbsp;:</td>
    	<td>
		  	<xsl:choose>
  				<xsl:when test="$ParamValue &lt; 0.001">
  					<span id="GoodValue"><xsl:value-of select="format-number($ParamValue * 1000000,'#')"/>&nbsp;&micro;<xsl:value-of select="$ParamUnit"/></span>
  				</xsl:when>
  				<xsl:when test="$ParamValue &lt; 1">
  					<span id="GoodValue"><xsl:value-of select="format-number($ParamValue * 1000,'#')"/>&nbsp;m<xsl:value-of select="$ParamUnit"/></span>
  				</xsl:when>
  				<xsl:when test="$ParamValue > 1000000">
  					<span id="GoodValue"><xsl:value-of select="format-number($ParamValue div 1000000,'#.###')"/>&nbsp;M<xsl:value-of select="$ParamUnit"/></span>
  				</xsl:when>
  				<xsl:when test="$ParamValue > 1000">
  					<span id="GoodValue"><xsl:value-of select="format-number($ParamValue div 1000,'#.###')"/>&nbsp;k<xsl:value-of select="$ParamUnit"/></span>
  				</xsl:when>
  				<xsl:otherwise>
            <span id="GoodValue"><xsl:value-of select="format-number($ParamValue,'#.###')"/>&nbsp;<xsl:value-of select="$ParamUnit"/></span>
		  		</xsl:otherwise>
  			</xsl:choose>
  		</td>
  	</tr>
  </xsl:template>


  <xsl:template name="FailValue">
    <xsl:param name="ParamName">-?-</xsl:param>
    <xsl:param name="ParamIndex"></xsl:param>
    <xsl:param name="ParamAdd"></xsl:param>
    <xsl:param name="ParamValue">-1</xsl:param>
    <xsl:param name="ParamUnit">-1</xsl:param>
    <tr valign="top">
  		<td class="resname"><xsl:value-of select="$ParamName"/><sub><xsl:value-of select="$ParamIndex"/></sub>&nbsp;<xsl:value-of select="$ParamAdd"/>&nbsp;:</td>
    	<td>
		  	<xsl:choose>
  				<xsl:when test="$ParamValue &lt; 0.001">
  					<span id="FailValue"><xsl:value-of select="format-number($ParamValue * 1000000,'#')"/>&nbsp;&micro;<xsl:value-of select="$ParamUnit"/></span>
  				</xsl:when>
  				<xsl:when test="$ParamValue &lt; 1">
  					<span id="FailValue"><xsl:value-of select="format-number($ParamValue * 1000,'#')"/>&nbsp;m<xsl:value-of select="$ParamUnit"/></span>
  				</xsl:when>
  				<xsl:when test="$ParamValue > 1000000">
  					<span id="FailValue"><xsl:value-of select="format-number($ParamValue div 1000000,'#.###')"/>&nbsp;M<xsl:value-of select="$ParamUnit"/></span>
  				</xsl:when>
  				<xsl:when test="$ParamValue > 1000">
  					<span id="FailValue"><xsl:value-of select="format-number($ParamValue div 1000,'#.###')"/>&nbsp;k<xsl:value-of select="$ParamUnit"/></span>
  				</xsl:when>
  				<xsl:otherwise>
            <span id="FailValue"><xsl:value-of select="format-number($ParamValue,'#.###')"/>&nbsp;<xsl:value-of select="$ParamUnit"/></span>
		  		</xsl:otherwise>
  			</xsl:choose>
  		</td>
  	</tr>
  </xsl:template>




	<xsl:template match="Voltage">
  	<tr valign="top">
	  	<td class="resname">Voltage&nbsp;:</td>
		  <td><xsl:apply-templates/></td>
		</tr>
	</xsl:template>
	
	
	
	<xsl:template match="VoltMeas">
  	<tr valign="top">
  		<td class="resname">VoltMeas&nbsp;:</td>
  		<td><xsl:apply-templates/></td>
  	</tr>
	</xsl:template>
	
	
	
	<xsl:template match="YesNoMode">
		<td class="resname">YesNoMode&nbsp;:</td>
		<td>
			<xsl:choose>
				<xsl:when test=". = 1">
					<span id="YesNoMode">YES-passed, NO-failed</span>
				</xsl:when>
				<xsl:when test=". = 2">
					<span id="YesNoMode">NO-passed, YES-failed</span>
				</xsl:when>
				<xsl:otherwise>
					<span id="YesNoMode">UNDEFINED</span>(<xsl:value-of select="."/>)
    </xsl:otherwise>
			</xsl:choose>
		</td>
	</xsl:template>
	
	
	
	<xsl:template match="Itype">
  	<tr valign="top">
  		<td class="resname">I type&nbsp;:</td>
  		<td>
  			<xsl:choose>
  				<xsl:when test=". = 1">
  					<span id="Itype">Real</span>
  				</xsl:when>
  				<xsl:when test=". = 2">
  					<span id="Itype">Total</span>
  				</xsl:when>
  				<xsl:otherwise>
  					<span id="Itype">UNDEFINED</span>(<xsl:value-of select="."/>)
          </xsl:otherwise>
  			</xsl:choose>
  		</td>
  	</tr>
	</xsl:template>
	
	
	
	<xsl:template match="Utype">
  	<tr valign="top">
  		<td class="resname">U type&nbsp;:</td>
  		<td>
  			<xsl:choose>
  				<xsl:when test=". = 1">
  					<span id="Utype">AC</span>
  				</xsl:when>
  				<xsl:when test=". = 2">
  					<span id="Utype">DC</span>
  				</xsl:when>
  				<xsl:when test=". = AC50">
  					<span id="Utype">AC 50Hz</span>
  				</xsl:when>
  				<xsl:when test=". = AC60">
  					<span id="Utype">AC 60Hz</span>
  				</xsl:when>
  				<xsl:when test=". = DC">
  					<span id="Utype">DC</span>
  				</xsl:when>
  				<xsl:otherwise>
  					<span id="Utype">UNDEFINED</span>(<xsl:value-of select="."/>)
          </xsl:otherwise>
  			</xsl:choose>
  		</td>
  	</tr>
	</xsl:template>



	<xsl:template match="VoltMeas">
  	<tr valign="top">
  		<td class="resname">Method&nbsp;:</td>
  		<td>
  			<xsl:choose>
  				<xsl:when test=". = 1">
  					<span id="VoltMeas">source (2-wires)</span>
  				</xsl:when>
  				<xsl:when test=". = 2">
  					<span id="VoltMeas">sense (4-wires)</span>
  				</xsl:when>
  				<xsl:otherwise>
  					<span id="VoltMeas">UNDEFINED</span>(<xsl:value-of select="."/>)
          </xsl:otherwise>
  			</xsl:choose>
  		</td>
  	</tr>
	</xsl:template>



	<xsl:template match="CompType">
  	<tr valign="top">
  		<td class="resname">Compare method&nbsp;:</td>
  		<td>
  			<xsl:choose>
  				<xsl:when test=". = 1">
  					<span id="CompType">master curve</span>
  				</xsl:when>
  				<xsl:when test=". = 2">
  					<span id="CompType">double test</span>
  				</xsl:when>
  				<xsl:when test=". = 3">
  					<span id="CompType">3-phase</span>
  				</xsl:when>
  				<xsl:otherwise>
  					<span id="CompType">UNDEFINED</span>(<xsl:value-of select="."/>)
          </xsl:otherwise>
  			</xsl:choose>
  		</td>
  	</tr>
	</xsl:template>



	<xsl:template name="SG_TestType">
    <tr valign="top">
		  <td class="resname">Test type&nbsp;:</td>
		  <td>
        <xsl:choose>
          <xsl:when test="(TestType mod (1 * 2)) - (TestType mod (1))">"Error area"</xsl:when>
          <xsl:otherwise></xsl:otherwise>
        </xsl:choose>

        <xsl:choose>
          <xsl:when test="(TestType mod (2 * 2)) - (TestType mod (2))">&nbsp;"Diff. area analysis"</xsl:when>
          <xsl:otherwise></xsl:otherwise>
        </xsl:choose>

        <xsl:choose>
          <xsl:when test="(TestType mod (4 * 2)) - (TestType mod (4))">&nbsp;"Damping process"</xsl:when>
          <xsl:otherwise></xsl:otherwise>
        </xsl:choose>

        <xsl:choose>
          <xsl:when test="(TestType mod (8 * 2)) - (TestType mod (8))">&nbsp;"Tolerance band"</xsl:when>
          <xsl:otherwise></xsl:otherwise>
        </xsl:choose>

        <xsl:choose>
          <xsl:when test="(TestType mod (16 * 2)) - (TestType mod (16))">&nbsp;"Frequency measuring"</xsl:when>
          <xsl:otherwise></xsl:otherwise>
        </xsl:choose>

        <xsl:choose>
          <xsl:when test="(TestType mod (32 * 2)) - (TestType mod (32))">&nbsp;"Corona"</xsl:when>
          <xsl:otherwise></xsl:otherwise>
        </xsl:choose>
		  </td>
		</tr>
	</xsl:template>



	<xsl:template name="SG_VoltageRange">
  	<tr valign="top">
  		<td class="resname">Voltage range&nbsp;:</td>
  		<td>
  			<xsl:choose>
  				<xsl:when test="Urange = 0">
  					<span id="CompType">auto</span>
  				</xsl:when>
  				<xsl:when test="Urange = 1">
  					<span id="CompType">8000 V</span>
  				</xsl:when>
  				<xsl:when test="Urange = 2">
  					<span id="CompType">4000 V</span>
  				</xsl:when>
  				<xsl:when test="Urange = 3">
  					<span id="CompType">1600 V</span>
  				</xsl:when>
  				<xsl:when test="Urange = 4">
  					<span id="CompType">800 V</span>
  				</xsl:when>
  				<xsl:when test="Urange = 5">
  					<span id="CompType">400 V</span>
  				</xsl:when>
  				<xsl:when test="Urange = 6">
  					<span id="CompType">160 V</span>
  				</xsl:when>
  				<xsl:otherwise>
  					<span id="CompType">UNDEFINED</span>(<xsl:value-of select="."/>)
          </xsl:otherwise>
  			</xsl:choose>
  		</td>
  	</tr>
	</xsl:template>



	<xsl:template match="ImpulsNr">
		<td class="resname">Impulses&nbsp;:</td>
		<td>
			<xsl:apply-templates/>
		</td>
	</xsl:template>



</xsl:stylesheet>
